#!/bin/sh

Dir_path=`dirname $0`
echo ${Dir_path}

wrap_cp()
{
   cp $@
   retcode=$?
   #echo "ret: ${retcode} after excute cp $@...\n"
   if [ ${retcode} -gt 1 ]
   then 
      if [ -d $3 ]; then
         #echo "rm -rf $3/*...\n"
         rm -rf $3/*
      else
         rm -rf $3
      fi
      #echo "cp again:cp $@...\n"
      cp $@	
   fi	
}

#only when need to reboot after updating, using it
while read line
do  
flag=$line
done < /tmp/ez_flag.log

if [ "X${flag}" == "X1" ]; then
   echo "it is updating now and can not be updated again...";
   exit 9;
fi 
     
echo 1 > /tmp/ez_flag.log
echo "begin updating now,pls waiting..."
#only when need to reboot after updating, using it

echo "cp -rf /data/upgrade.md5 /tmp/upgrade.md5" 
cp -rf /data/upgrade.md5 /tmp/upgrade.md5

#copy /dvr
wrap_cp -rf ${Dir_path}/*  /tmp/



lang=`ls /tmp/*.tar| cut -d "." -f1|cut -d "_" -f3`
if [ "X$lang" == "XEN" ] ; then
   /dvr/app/unix_socket "/private/language=1"
elif [ "X$lang" == "XCN" ] ; then
   /dvr/app/unix_socket "/private/language=2"
elif [ "X$lang" == "XRS" ] ; then
   /dvr/app/unix_socket "/private/language=3"
elif [ "X$lang" == "XKR" ] ; then
   /dvr/app/unix_socket "/private/language=4"
elif [ "X$lang" == "XJP" ] ; then
   /dvr/app/unix_socket "/private/language=5"
elif [ "X$lang" == "XFR" ] ; then
   /dvr/app/unix_socket "/private/language=6"
elif [ "X$lang" == "XDE" ] ; then
   /dvr/app/unix_socket "/private/language=7"
fi

#killall main app
d=`find /dvr/ -name i2ccmd | wc -l`
if [ $d -eq 1 ] ; then
	a=`ps | grep app_start.sh | grep -v "grep" | awk '{print $1}'`
	kill $a
	killall dvr_app
	killall smbd
	killall nmbd

	#forbid watchdog
	/dvr/app/i2ccmd a 78 
	/dvr/app/i2ccmd W aa 6 2 0 0 b2
fi

/dvr/app/usrbin/wgpio w 27 1
usleep 500000
/dvr/app/usrbin/wgpio w 27 0
usleep 500000
/dvr/app/usrbin/wgpio w 27 1
usleep 500000
/dvr/app/usrbin/wgpio w 27 0

sleep 3

#tell if updating the old bootloader
ub=`nvram_get uboot version`
if [ "X$ub" != "X6.1.1.0-160801" ] ; then
  echo "updating uboot now..."
  rmmod i2c_drv
  insmod  /tmp/dvr/ko/i2c_drv.ko
  sleep 1
  /tmp/dvr/app/usrbin/ubootflash -f /tmp/uboot.img
  nvram_set uboot version 6.1.1.0-160801
fi

	a=`ls /dvr/* | wc -l`
	if [ $a -gt 1 ]; then                                
                #lang=`ls /tmp/*.tar| cut -d "." -f1|cut -d "_" -f3`
                para=`ls /tmp/*.tar| cut -d "." -f1|cut -d "_" -f2`
                channels=`expr substr "$para" 1 1`
                mode=`expr substr "$para" 2 1`
                dt=`ls /tmp/*.tar| cut -d "." -f1|cut -d "_" -f1|cut -d "R" -f2`
		
                if [ "X$lang" != "X" ] ; then
                  cp -f /tmp/dvr/app/ezdvr_$lang.cfg /tmp/dvr/app/ezdvr.cfg.default
                  cp -f /tmp/data/cfg/config_$lang.lua /tmp/data/cfg/config.lua.default
                else
                  cp -f /tmp/dvr/app/ezdvr.cfg /tmp/dvr/app/ezdvr.cfg.default
                  cp -f /tmp/data/cfg/config.lua /tmp/data/cfg/config.lua.default
                fi
                
		if [ "X$mode" != "XP" ] ; then
                  if [ "X$lang" != "X" ] ; then
                     cp -f /data/cfg/config.lua /tmp/data/cfg/config_$lang.lua
                     cp -f /dvr/app/ezdvr.cfg   /tmp/dvr/app/ezdvr_$lang.cfg 
                  else
                     cp -f /data/cfg/config.lua /tmp/data/cfg/config.lua 
                     cp -f /dvr/app/ezdvr.cfg   /tmp/dvr/app/ezdvr.cfg                            
                  fi
                  cp -f  /dvr/app/usrbin/ppp/*   /tmp/dvr/app/usrbin/ppp/
                else
                  ralink_init clear 2860
                  ralink_init renew 2860 /tmp/data/RT2860_default_vlan 
                fi                                             
		echo "rm /dvr/*"
		rm -rf /dvr/*
		echo "rm /data/*"
		rm -rf /data/*
		echo "cp -rf /tmp/dvr/* /dvr/"
		cp -rf /tmp/dvr/* /dvr/
		echo "cp -rf /tmp/data/* /data/"
		cp -rf /tmp/data/* /data/         
		echo "cp /tmp/upgrade.md5 /data/upgrade.md5"     
		cp -rf /tmp/upgrade.md5 /data/upgrade.md5
                if [ "X$lang" != "X" ] ; then
                   cp -f /data/cfg/config_$lang.lua /data/cfg/config.lua 
                   cp -f /dvr/app/ezdvr_$lang.cfg   /dvr/app/ezdvr.cfg
                fi
                rm /data/cfg/config_*.lua
                rm /dvr/app/ezdvr_*.cfg 
                /bin/ffdb -d /data/cfg/config.lua WEBS_VERSION "V1.2${channels}.${dt}"  
                cp -f /data/cfg/config.lua       /dvr/lighttpd/cfg/             
	else
		echo "/tmp/dvr/reflash_dvr.sh"
		/tmp/dvr/reflash_dvr.sh
		echo "/tmp/data/reflash_data.sh"
		/tmp/data/reflash_data.sh
	fi

echo "update over and reboot now..."
/tmp/sysreboot.sh &

/dvr/app/usrbin/wgpio w 27 1
usleep 500000
/dvr/app/usrbin/wgpio w 27 0

exit 9
