#!/bin/sh

#sleep 15

##########check LAN MAC address ##############3
check_lanMac()
{
  wifiMac4=`/data/flash -r 40007 -c 1`
  wifiMac5=`/data/flash -r 40008 -c 1`
  wifiMac6=`/data/flash -r 40009 -c 1`
  wifiMac456=${wifiMac4}${wifiMac5}${wifiMac6}
  
  lanTarMac4=00
  if [ ${wifiMac4} == "00" ]; then
  lanTarMac4=80
  fi
  
  lanMac456=`/data/flash -r 4002b -c 3`
  
  echo wifiMac456=${wifiMac456},lanMac456=${lanMac456}
  
  if [ "${lanMac456}" != "${lanTarMac4}${wifiMac5}${wifiMac6}" ] ; then
    iwMac34=${lanTarMac4}00
    iwMac56=${wifiMac6}${wifiMac5}
    iwpriv ra0 e2p 2a=${iwMac34}
    iwpriv ra0 e2p 2c=${iwMac56}
    
    resLanMac3456=`/data/flash -r 4002a -c 4`
    echo "new lanMac3456=${resLanMac3456}"
  fi
}
##########check LAN MAC address end ##############



#tell if LAN first
LAN_PRIORITY=$(/bin/ffdb -d /data/cfg/config.lua  SYSTEM_LAN_PRIORITY)
if [ "X$LAN_PRIORITY" == "X1" ] ; then
   ip=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_LAN_IP)
   sip=`nvram_get lan_ipaddr`
   if [ $sip != $ip ]
   then
     nvram_set lan_ipaddr $ip   
   fi

   netmask=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_LAN_NETMASK)
   snm=`nvram_get lan_netmask`
   if [ $snm != $netmask ]
   then
     nvram_set lan_netmask $netmask
   fi	 
fi 

#tell if dhcp forbidden
DHCPD=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_AP_DHCP_ENABLED)
if [ "X$DHCPD" == "X0" ] || [ "X$DHCPD" == "X" ]
then
  DHCPE=`nvram_get dhcpEnabled`
  if [ "X$DHCPE" != "X0" ]
  then
     nvram_set dhcpEnabled 0
  fi
fi

#tell if SSID is null          
APSSID=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_AP_SSID)
if [ "X$APSSID" == "X" ] || [ "X$APSSID" == "X " ] || [ "X$APSSID" == "X\"\"" ]
then
  #a=`ifconfig ra0 2>&- | grep Link | awk -F : '{print $5 $6 $7}' | awk '{print $1}'`
  #ra=`cat /proc/sys/kernel/random/uuid`
  #ra=`head -200 /dev/urandom | cksum | cut -f1 -d" "`
  #a=`expr substr "$ra" 1 6`
  a=`/data/flash -r 40007 -c 3`
	nvram_set SSID1 HDVR_$a
	b=`nvram_get SSID1`
	
	echo wifiMac=$a,SSID1=$b
	
	/bin/ffdb -d /data/cfg/config.lua -q SYSTEM_AP_SSID $b
	/bin/ffdb -d /dvr/lighttpd/cfg/config.lua -q SYSTEM_AP_SSID $b
	/data/wifizconf.sh start
else
  BPSSID=`nvram_get SSID1`
  if [ "X$APSSID" != "X$BPSSID" ]
  then
     /data/wifizconf.sh start	
  else
     internet.sh
  fi
fi

WIFI_ENABLED=$(/bin/ffdb -d /data/cfg/config.lua  SYSTEM_WIFI_ENABLED)
if [ $WIFI_ENABLED == "0" ] ; then
	#a=`nvram_get lan_ipaddr`
	#ifconfig eth2 $a netmask 255.255.255.0 
	#internet.sh
	ifconfig ra0 down
	ifconfig apcli0 down
elif [ $WIFI_ENABLED == "1" ] ; then
	#nvram_set OperationMode 0
	#internet.sh
	ifconfig apcli0 down
elif [ $WIFI_ENABLED == "2" ] ; then
	#internet.sh
	ifconfig ra0 down
fi
#if [ $WIFI_ENABLED == "3" ] ; then
#		internet.sh

#fi	
/data/20network start
/data/mac.sh
dnsmasq start&

smb=`nvram_get 2860 SmbEnabled`
if [ "X$smb" != "X1" ]
then
	nvram_set 2860 SmbEnabled 1
fi
/data/storage.sh samba

echo 8192 > /proc/sys/vm/min_free_kbytes

/data/automode &

#IP_MODE=$(/bin/ffdb -d /data/cfg/config.lua  SYSTEM_WIFI_IP_MODE)
#if [ $IP_MODE == 0 ]; then
#        DHCPC=`nvram_get wanConnectionMode`
#        if [ "X$DHCPC" == "XDHCP" ]
#        then
#          killall udhcpc
#          nvram_set wanConnectionMode STATIC
#        fi        
#	ip=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_IP)
#	netmask=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_NETMASK)
#	gateway=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_GATEWAY)
#	ifconfig apcli0 $ip netmask $netmask
#	route add default gw $gateway
#fi

if [ "X$LAN_PRIORITY" == "X1" ] ; then
   gateway=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_LAN_GATEWAY)
   if [ "X$gateway" != "X0.0.0.0" ] && [ "X$gateway" != "X" ] ; then
     route add default gw $gateway br0
     echo "nameserver $gateway" > /etc/resolv.conf
   fi   
fi 

check_lanMac

  