#!/bin/sh  
#
# WIFI and Zero config configuration script
#
#

log()
{
	#logger $1
	#echo "@@@@@ $1 #####"
	echo $1 
}


DEV=ra0
DHCP_PID_FILE="/var/run/udhcpc-wifi.pid" 
DHCPD_PID_FILE="/var/run/udhcpd-wifi.pid" 
TMP=/tmp/1

start()
{
	ERR=0
        echo "WebInit=1" > /tmp/wifizconf.conf
		
  # Set client
	WIFI_AUTH_ENC=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_AUTH_ENC)
	WIFI_SSID=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_SSID)
	WIFI_KEY=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_KEY)
        WIFI_CHANNEL=$(/bin/ffdb -d /data/cfg/config.lua SYSTEM_AP_CHANNEL)
        COUNTRYREGION=$(/bin/ffdb -d /data/cfg/config.lua SYSTEM_WIFI_COUNTRYREGION)
  
	# Bring Up the device
	/bin/nvram_set OperationMode 3
	/bin/nvram_set ApCliEnable 1

	# Set CountryRegion code 
	/bin/nvram_set CountryRegion ${COUNTRYREGION}   
	/bin/nvram_set Channel ${WIFI_CHANNEL}
        if [ "" != $WIFI_SSID ]
	then
	  /bin/nvram_set ApCliSsid "${WIFI_SSID}"	
        else
          /bin/nvram_set ApCliSsid fangch	
        fi	
	
        if [ "WPAPSK_TKIP" == $WIFI_AUTH_ENC ] 
	then		
		/bin/nvram_set ApCliAuthMode WPAPSK
		/bin/nvram_set ApCliEncrypType TKIP
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"		
	elif [ "WPAPSK2_TKIP" == $WIFI_AUTH_ENC ]
	then
		/bin/nvram_set ApCliAuthMode WPA2PSK
		/bin/nvram_set ApCliEncrypType TKIP
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"	
	elif [ "WPAPSK_AES" == $WIFI_AUTH_ENC ]
	then
		/bin/nvram_set ApCliAuthMode WPAPSK
		/bin/nvram_set ApCliEncrypType AES
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"
	elif [ "WPAPSK2_AES" == $WIFI_AUTH_ENC ]
	then
		/bin/nvram_set ApCliAuthMode WPA2PSK
		/bin/nvram_set ApCliEncrypType AES
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"
	else
		/bin/nvram_set ApCliAuthMode OPEN
		/bin/nvram_set ApCliEncrypType NONE
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"
	fi	

  # set ap
	APSSID=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_AP_SSID)	
	/bin/nvram_set SSID1 "${APSSID}"
	
	APSECURITY=$(/bin/ffdb -d /data/cfg/config.lua -q SYSTEM_AP_SECURITY)
	PASSWORD=$(/bin/ffdb -d /data/cfg/config.lua -q SYSTEM_AP_PASSWORD)
	if [ "WPAPSK_TKIP" == $APSECURITY ] 
	then		
		/bin/nvram_set AuthMode WPAPSK
		/bin/nvram_set EncrypType TKIP
		/bin/nvram_set WPAPSK1 "${PASSWORD}"		
	elif [ "WPAPSK2_TKIP" == $APSECURITY ]
	then
		/bin/nvram_set AuthMode WPA2PSK
		/bin/nvram_set EncrypType TKIP
		/bin/nvram_set WPAPSK1 "${PASSWORD}"	
	elif [ "WPAPSK_AES" == $APSECURITY ]
	then
		/bin/nvram_set AuthMode WPAPSK
		/bin/nvram_set EncrypType AES
		/bin/nvram_set WPAPSK1 "${PASSWORD}"
	elif [ "WPAPSK2_AES" == $APSECURITY ]
	then
		/bin/nvram_set AuthMode WPA2PSK
		/bin/nvram_set EncrypType AES
		/bin/nvram_set WPAPSK1 "${PASSWORD}"
	else
		/bin/nvram_set AuthMode OPEN
		/bin/nvram_set EncrypType NONE
		#/bin/nvram_set WPAPSK1 "${PASSWORD}"
	fi
	internet.sh
	dnsmasq start&
        echo "WebInit=0" > /tmp/wifizconf.conf
  
	return ${ERR}
}

set_ap()
{
  echo "WebInit=1" > /tmp/wifizconf.conf
  
  # set ap
	APSSID=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_AP_SSID)
	WIFI_CHANNEL=$(/bin/ffdb -d /data/cfg/config.lua SYSTEM_AP_CHANNEL)	
	/bin/nvram_set SSID1 "${APSSID}"
	/bin/nvram_set Channel ${WIFI_CHANNEL}
	
	APSECURITY=$(/bin/ffdb -d /data/cfg/config.lua -q SYSTEM_AP_SECURITY)
	PASSWORD=$(/bin/ffdb -d /data/cfg/config.lua -q SYSTEM_AP_PASSWORD)
	if [ "WPAPSK_TKIP" == $APSECURITY ] 
	then		
		/bin/nvram_set AuthMode WPAPSK
		/bin/nvram_set EncrypType TKIP
		/bin/nvram_set WPAPSK1 "${PASSWORD}"		
	elif [ "WPAPSK2_TKIP" == $APSECURITY ]
	then
		/bin/nvram_set AuthMode WPA2PSK
		/bin/nvram_set EncrypType TKIP
		/bin/nvram_set WPAPSK1 "${PASSWORD}"	
	elif [ "WPAPSK_AES" == $APSECURITY ]
	then
		/bin/nvram_set AuthMode WPAPSK
		/bin/nvram_set EncrypType AES
		/bin/nvram_set WPAPSK1 "${PASSWORD}"
	elif [ "WPAPSK2_AES" == $APSECURITY ]
	then
		/bin/nvram_set AuthMode WPA2PSK
		/bin/nvram_set EncrypType AES
		/bin/nvram_set WPAPSK1 "${PASSWORD}"
	else
		/bin/nvram_set AuthMode OPEN
		/bin/nvram_set EncrypType NONE
		#/bin/nvram_set WPAPSK1 "${PASSWORD}"
	fi
	internet.sh
	dnsmasq start&
	
	echo "WebInit=0" > /tmp/wifizconf.conf
}

set_client()
{		
	echo "WebInit=1" > /tmp/wifizconf.conf
  
        # Set client
	WIFI_AUTH_ENC=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_AUTH_ENC)
	WIFI_SSID=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_SSID)
	WIFI_KEY=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_KEY)
        WIFI_CHANNEL=$(/bin/ffdb -d /data/cfg/config.lua SYSTEM_AP_CHANNEL)
        COUNTRYREGION=$(/bin/ffdb -d /data/cfg/config.lua SYSTEM_WIFI_COUNTRYREGION)
  
	# Bring Up the device
	/bin/nvram_set OperationMode 3
	/bin/nvram_set ApCliEnable 1

	# Set CountryRegion code 
	/bin/nvram_set CountryRegion ${COUNTRYREGION}   
	/bin/nvram_set Channel ${WIFI_CHANNEL}
	if [ "" != $WIFI_SSID ]
	then
	  /bin/nvram_set ApCliSsid "${WIFI_SSID}"	
        else
          /bin/nvram_set ApCliSsid fangch	
        fi
  
        WIFI_AUTH_ENC=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_AUTH_ENC)
	WIFI_KEY=$(/bin/ffdb -d /data/cfg/config.lua  -q SYSTEM_WIFI_KEY)	
	if [ "WPAPSK_TKIP" == $WIFI_AUTH_ENC ] 
	then		
		/bin/nvram_set ApCliAuthMode WPAPSK
		/bin/nvram_set ApCliEncrypType TKIP
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"		
	elif [ "WPAPSK2_TKIP" == $WIFI_AUTH_ENC ]
	then
		/bin/nvram_set ApCliAuthMode WPA2PSK
		/bin/nvram_set ApCliEncrypType TKIP
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"	
	elif [ "WPAPSK_AES" == $WIFI_AUTH_ENC ]
	then
		/bin/nvram_set ApCliAuthMode WPAPSK
		/bin/nvram_set ApCliEncrypType AES
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"
	elif [ "WPAPSK2_AES" == $WIFI_AUTH_ENC ]
	then
		/bin/nvram_set ApCliAuthMode WPA2PSK
		/bin/nvram_set ApCliEncrypType AES
		/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"
	else
		/bin/nvram_set ApCliAuthMode OPEN
		/bin/nvram_set ApCliEncrypType NONE
		#/bin/nvram_set ApCliWPAPSK "${WIFI_KEY}"
	fi	
	internet.sh
	
	echo "WebInit=0" > /tmp/wifizconf.conf
}

set_mode()
{
	WIFI_ENABLED=$(/bin/ffdb -d /data/cfg/config.lua  SYSTEM_WIFI_ENABLED)
	if [ $WIFI_ENABLED == "0" ] ; then
		ifconfig ra0 down
		ifconfig apcli0 down
	fi
	if [ $WIFI_ENABLED == "1" ] ; then
		ifconfig ra0 up
		ifconfig apcli0 down
	fi
	if [ $WIFI_ENABLED == "2" ] ; then
		set_client
		ifconfig ra0 down
	fi
	if [ $WIFI_ENABLED == "3" ] ; then
		set_client
	fi		
}

dhcp_stop()
{

	if [ -r ${DHCP_PID_FILE} ]                                                   
	then                                                                                                
		/bin/kill $(cat ${DHCP_PID_FILE})                          
		if [ "X$?" != "X0" ]                                                                       
		then  
			ERR=9                        
		fi                                                       
	fi                                                             

	if [ -r ${DHCPD_PID_FILE} ]                                                   
	then                                                                                                
		/bin/kill $(cat ${DHCPD_PID_FILE})                          
		if [ "X$?" != "X0" ]                                                                       
		then  
			ERR=10               
		fi                                                       
	fi 

}
	
# See how we were called.
case "$1" in  
  start)
	start
	RETVAL=$?
	return $RETVAL
        ;;
  setap)
	set_ap
	;;
  setclient)
	set_client
        ;;
  setmode)
	set_mode
        ;;         	
  wifi)
	/bin/iwpriv ra0 set SiteSurvey=1
	/bin/iwpriv ra0 get_site_survey
	;;
  3G)
	nvram_set OperationMode 1
	nvram_set wanConnectionMode 3G
	internet.sh
	;;
  apcli)
  	nvram_set OperationMode 3
  	nvram_set wanConnectionMode DHCP
  	nvram_set ApCliEnable 1
  	nvram_set ApCliSsid MERCURY-ES
  	nvram_set ApCliAuthMode WPAPSK
  	nvram_set ApCliEncrypType AES
  	nvram_set ApCliWPAPSK szest123
  	nvran_set Channel 5
  	internet.sh
  	;;		 
  status)
	RETVAL=0
	/usr/sbin/avahi-autoipd ${DEV} --check
	if [ "X$?" == "X0" ]; then
		echo "autoipd is running"
	fi
	/usr/sbin/avahi-daemon --check
	if [ "X$?" == "X0" ]; then
		echo "avahi-daemon is running"
	fi
	/usr/sbin/avahi-dnsconfd --check
	if [ "X$?" == "X0" ]; then
		echo "avahi-dnsconfd is running"
	fi
	is_wifi_loaded
	if [ $wifi_drv_st ==  0 ] ; then
		echo "wifi driver is not loaded"
		RETVAL=11
	fi
        /bin/iwpriv ${DEV} connStatus
	RETVAL=$?
        ;;
  scan)
	RETVAL=0
		/data/wifizconf.sh cgiscan 
		
		awk -F ':' 'BEGIN {
		nxtln=0;	
		isenc=0;
		auth=0;
		cipher=0;
		sec=0;
		hasie=1;
		secfound=0;
		firstcell=1;
		exitenc=0;
		firstsec="security=";
		} {
		a=index($1,"Cell ")
		if (a != 0) {
			if (hasie == 0 )
			{
				printf("security=WEP_SHARED")	
				hasie = 1;
			}
			if (!firstcell)	{
				#printf ("%s:%s:%s\t",isenc,secfound,exitenc)
				if(isenc == 0 && secfound == 0 && exitenc == 0) {
					printf("security=WEP_SHARED")	
				}
				printf("\n");
			}			
			gsub(/^[ \t]+|[ \t]+$/,"",$2)
			bssid=$2":"$3":"$4":"$5":"$6":"$7
			#printf("ebssid=%s\t",ebssid)
			printf("bssid=%s\t",bssid)
			if(bssid == ebssid) {
				printf("connected=1\t")
			} else {
				printf("connected=0\t")
			}
			firstcell=0;
			secfound=0;
			exitenc=0;
			firstsec="security=";
		} else {
			if($1 == "                    Protocol") {
				capability=$2
				printf("capability=%s\t",capability)
			} else if($1 == "                    ESSID") {
				printf("ssid=%s\t",$2)
			} else if($1 == "                    Frequency") {
				printf("Freq=Channel \"%s\"\t",$2)
				
				# Get next line
				#getline nxtln;
				#signal=substr(nxtln,29,3)
				#printf("sigstrength=%3d\t",signal)
			} else if($1 == "                    Signal") {
				printf("sigstrength=%s\t",$2)
			} else if($1 == "                    Encryption key") {
				if ($2 == "on") {
					isenc=1
				}else {
					isenc=0
				}
				if(isenc == 0) {
					printf("%sOPEN_NONE",firstsec)
					exitenc=1;
					hasie=1;
				} else {
					hasie=0;	
				}
			} else if($1 == "                    IE") {
				isenc=0
				hasie=1;
				a=index($2,"Unknown")
				if(a)
					break
				secfound=0;
				a=index($2,"WPA Version 1")
				b=index($2,"WPA2 Version 1")
				if ( a != 0) {
					sec="WPA"
					secfound=1
				} else if ( b != 0 ) {
					sec="WPA2"
					secfound=1
				
				}
				getline nxtln
				getline nxtln
				a=index(nxtln,"CCMP")
				b=index(nxtln,"TKIP")
				if ( a && b ) {
				cipher="AES/TKIP"
				} else if (a) {
					cipher="AES"
				} else if (b) {
					cipher="TKIP"	
				} else {
					cipher="UNKNOWN"
				}
				getline nxtln
				a=index(nxtln,"PSK")
				b=index(nxtln,"802.1x")
				if(a) {
					auth="PSK"
				} else if (b) {
					auth="ENT"
				} else {
					auth="UNKNOWN"
				}
			
			
				if(secfound) {
					if(sec == "WPA" && auth == "PSK" && ( cipher == "AES/TKIP") && (capability == "802.11b/g/n" || capability == "802.11g/n" || capability == "802.11n") ) {
						printf("%sWPAPSK_AES",firstsec)
					} else if(sec == "WPA" && auth == "PSK" && ( cipher == "TKIP"|| cipher == "AES/TKIP")) {
						printf("%sWPAPSK_TKIP",firstsec)
					} else if(sec == "WPA2" && auth == "PSK" && ( cipher == "AES/TKIP") && (capability == "802.11b/g/n" || capability == "802.11g/n" || capability == "802.11n") ) {
						printf("%sWPAPSK2_AES",firstsec)
					} else if(sec == "WPA2" && auth == "PSK" && ( cipher == "TKIP"|| cipher == "AES/TKIP")) {
						printf("%sWPAPSK2_TKIP",firstsec)
					} else if(sec == "WPA" && auth == "PSK" && ( cipher == "AES"|| cipher == "AES/TKIP")) {
						printf("%sWPAPSK_AES",firstsec)
					} else if(sec == "WPA2" && auth == "PSK" && ( cipher == "AES"|| cipher == "AES/TKIP")) {
						printf("%sWPAPSK2_AES",firstsec)
					} else if(sec == "WPA" && auth == "ENT" && ( cipher == "TKIP"|| cipher == "AES/TKIP")) {
						printf("%sWPAENT_TKIP",firstsec)
					} else if(sec == "WPA2" && auth == "ENT" && ( cipher == "TKIP"|| cipher == "AES/TKIP")) {
							printf("%sWPAENT2_TKIP",firstsec)
					} else if(sec == "WPA" && auth == "ENT" && ( cipher == "AES"|| cipher == "AES/TKIP")) {
							printf("%sWPAENT_AES",firstsec)
					} else if(sec == "WPA2" && auth == "ENT" && ( cipher == "AES"|| cipher == "AES/TKIP")) {
							printf("%sWPAENT2_AES",firstsec)
					}
				} else {	
						printf("%sUNKNOWN")
				}
					# make next security modes in "/" seprated
					firstsec="/"
				} 
		}
		} END {
				if (hasie == 0 )
				{
					printf("security=WEP_SHARED")	
					hasie = 1;
				}
				if (!firstcell)	{	
					if(isenc == 0 && secfound == 0 && exitenc == 0) {
						printf("security=WEP_SHARED")	
					}
				}
		}' /tmp/scan2.txt
	RETVAL=$?
        ;;
  cgiscan)
	RETVAL=0
		rm -rf /tmp/scan2.txt
		/bin/iwpriv ra0 set SiteSurvey=1
	        /bin/iwpriv ra0 get_site_survey | sed '1d 2d $d' | sed 's/[,] /,/g' > $TMP		
		count=`wc -l $TMP | awk '{print $1}'`
		n=0
		m=1
		echo -e "ra0       Scan completed :" >>/tmp/scan2.txt
		while [ $m -le $count ]
		do
			#echo -e "<device>"			
			bssid=`awk '{if (NR=='$m') print $3}' $TMP`
			echo -e "          Cell  $m - Address:$bssid" >>/tmp/scan2.txt
			
			capability=`awk '{if (NR=='$m') print $6}' $TMP`
			echo -e "                    Protocol:$capability" >>/tmp/scan2.txt
			
			ssid=`awk '{if (NR=='$m') print $2}' $TMP`
			echo -e "                    ESSID:"$ssid"" >>/tmp/scan2.txt
			
			chan=`awk '{if (NR=='$m') print $1}' $TMP`
			echo -e "                    Frequency:$chan" >>/tmp/scan2.txt
			
			sigstrength=`awk '{if (NR=='$m') print $5}' $TMP`
			echo -e "                    Signal:$sigstrength" >>/tmp/scan2.txt
			
			security=`awk '{if (NR=='$m') print $4}' $TMP`
			if [ "$security" = "WEP" ] ; then	
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt	
			elif [ "$security" = "WPAPSK/AES" ] ; then
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt
				echo -e "                    IE: WPA Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : CCMP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (1) :CCMP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) :PSK" >>/tmp/scan2.txt	
			elif [ "$security" = "WPAPSK/TKIP" ] ; then
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt
				echo -e "                    IE: WPA Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : TKIP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (1) :TKIP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) :PSK" >>/tmp/scan2.txt	
			elif [ "$security" = "WPA2PSK/AES" ] ; then
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt
				echo -e "                    IE: IEE802.11i/WPA2 Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : CCMP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (1) : CCMP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) : PSK" >>/tmp/scan2.txt
				echo -e "                    IE: Unknown: DFD98787687619023480" >>/tmp/scan2.txt
			elif [ "$security" = "WPA2PSK/TKIP" ] ; then
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt
				
				echo -e "                    IE: IEEE 802.11i/WPA2 Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : TKIP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (1) : TKIP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) : PSK" >>/tmp/scan2.txt
			elif [ "$security" = "WPA1PSKWPA2PSK/TKIPAES" ] ; then
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt
				echo -e "                    IE: WPA Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : TKIP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (2) : TKIP CCMP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) : PSK" >>/tmp/scan2.txt
				echo -e "                    IE: IEEE 802.11i/WPA2 Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : TKIP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (2) : TKIP CCMP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) : PSK" >>/tmp/scan2.txt
				echo -e "                    IE: Unknown: DD0E0050F204104A000110104400010254335" >>/tmp/scan2.txt
			elif [ "$security" = "WPA1PSKWPA2PSK/AES" ] ; then
				echo -e "                    Encryption key:on" >>/tmp/scan2.txt
				echo -e "                    IE: WPA Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Cipher : CCMP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (1) : CCMP" >>/tmp/scan2.txt
				echo -e "                        Authentication Suites (1) : PSK" >>/tmp/scan2.txt
				echo -e "                    IE: IEEE 802.11i/WPA2 Version 1" >>/tmp/scan2.txt
				echo -e "                        Group Ciphers : CCMP" >>/tmp/scan2.txt
				echo -e "                        Pairwise Ciphers (1) : CCMP" >>/tmp/scan2.txt
				echo -e "                    IE: Unknown: DD31008979879837DFF7238529375" >>/tmp/scan2.txt
			elif [ "$security" = "NONE" ] ; then
				echo -e "                    Encryption key:off" >>/tmp/scan2.txt	
			fi	
			n=`expr $n + 1`
			m=`expr $m + 1`
		done
	RETVAL=$?
        ;;
  *)
        echo $"Usage: $0 {start|wifi|3G|apcli|status|scan|cgiscan}"
        exit 12
esac

exit $RETVAL
