/*
 * Maxim Integrated Products
 * India Design Center
 *
 * Copyright (c) 2010 Maxim Integrated Products
 *
 * File: $URL: $
 *
 * Description: Contains functions to generate HTML code to embed Video and Image streams
 *
 * Originators: Barry Smith
 *
 * $Id: $
 */

var timer;
var imageURL;
var imageWidth;
var imageHeight;
var cameraSelect=4;
var cameraMode=CameraType.live;
var newImage = new Image();
var clearTimer = false;
var currentCameraMode;
/**
 * @brief Embed the VLC plugin to enable RTSP streaming
 */
var embed;
function embedVLC( stream, width, height,cam,cam_mode) {

    //var vlccontent;
	
	cameraSelect = cam;	
	
	clearImageTimer();
/*
    if(cam_mode == CameraType.live)
	   vlccontent="vlclivecontent";
	else
	   vlccontent="vlcsettingcontent";
	document.getElementById(vlccontent.toString()).style.visibility = "visible";
*/
	document.getElementById("vlccontent").style.visibility = "visible";

	//if(IE) 
		{
		// fix for video streaming in IE
		// IE requires the <object/> html tag to be present statically on the HTML page,
		// and not be dynamically added
		var mystream;
		var myvlc;
		var myindex= parseInt(cam/5,10);
		//alert("embedVLC camara="+cam.toString());
		if((cam_mode == CameraType.live) && ((cam%5) == 4))
		{
		    var vlcString;
			var vlcID;
			var vlc_controls;
			
		    vlcString = '<table border="2" cellpadding="0" cellspacing="0">';
			vlcString += '<tr>';
			vlcString += '<td style="margin:0;padding:0"><div id="vlccontent0"></div></td>';
			vlcString += '<td style="margin:0;padding:0"><div id="vlccontent1"></div></td>';
			vlcString += '</tr>';

			vlcString += '<tr>';
			vlcString += '<td style="margin:0;padding:0"><div id="vlccontent2"></div></td>';
			vlcString += '<td style="margin:0;padding:0"><div id="vlccontent3"></div></td>';
			vlcString += '</tr>';

			vlcString += '</table>';

			//$("#"+vlccontent.toString()).html(vlcString);
			$("#vlccontent").html(vlcString);

		
           for(var i=0;i<4;i++)
		   {
		        vlcID = "vlccontent" + i.toString();
				mystream = "rtpstream" + i.toString();
				myvlc = new VLCObject(mystream, width/2, height/2);
				myvlc.write(vlcID);
				vlc_controls = new VLCcontrols(myvlc, false);

				// If this a remote session, then enable RTP over TCP
				if( (location.port) && (location.port != 80) ) {
					//alert(location.port);
					//vlc_controls.options.set("rtp-client-port", location.port.toString());					
					//vlc_controls.options.set("rtsp-http-port", location.port.toString());
					//vlc_controls.options.set("rtsp-tcp", "true");
					//vlc_controls.options.set("http-reconnect");
				}
				vlc_controls.options.set("rtsp-caching", "0");		
				//vlc_controls.options.set("network-caching", "300");	
				//vlc_controls.options.set("live-caching", "200");

				
				mystream = "vga" + (i+1+myindex*4);
				vlc_controls.doPlay(stream+mystream);
				vlc_controls.changeVolume(0);
		   }		   
		}
		else
		{
		    //alert("vlccontent="+vlccontent.toString());
		    mystream = "rtpstream" + cam.toString();
			if(cam_mode == CameraType.live)
			   stream  += "hd" + (1+parseInt(cam/5,10)*4+cam%5).toString();
			else
			   stream  += "vga" +(cam+1);
			myvlc = new VLCObject(mystream, width, height);
			myvlc.write("vlccontent");
			var vlc_controls = new VLCcontrols(myvlc, false);

			// If this a remote session, then enable RTP over TCP
			if( (location.port) && (location.port != 80) ) {
				//vlc_controls.options.set("rtsp-tcp", "true");
				//vlc_controls.options.set("http-reconnect");
			}
			vlc_controls.options.set("rtsp-caching", "0");
			//vlc_controls.options.set("network-caching", "300");
			//vlc_controls.options.set("live-caching", "250");
			vlc_controls.doPlay(stream);
			
		}       
	
	}
	/*
	else
	{
		// For other browsers, dynamically add the <object/> HTML to the page
		embed = document.createElement("embed");
		embed.setAttribute("type","application/x-vlc-plugin");
		
		embed.setAttribute("id","vlc");
		embed.setAttribute("width",width);
		embed.setAttribute("height",height);
		embed.setAttribute("autoplay","yes");
		stream  += "stream" + cam.toString();
		embed.setAttribute("target",stream);

		document.getElementById(vlccontent.toString()).appendChild(embed);
	}
	*/
}

/**
 * @brief Embed quicktime player for HttpLive streaming
 */
function embedHttpLive (stream, width, height) {
/*
	var embed = document.createElement("embed");
	embed.setAttribute("type","video/quicktime");
	
	embed.setAttribute("id","httplive");
	embed.setAttribute("width",width);
	embed.setAttribute("height",height);
	embed.setAttribute("autoplay",true);
	embed.setAttribute("src",stream);
	embed.setAttribute("controller",true);
	embed.setAttribute("scale","aspect");
	embed.setAttribute("pluginspage","http://www.apple.com/quicktime/download/");
	embed.setAttribute("airplay","allow");

	var httplivecontent = document.getElementById("httplivecontent");
	httplivecontent.appendChild(embed);
	*/
	var vlcString='<video tabindex="0" height="176" width="320"><source src="/maxim/stream1.m3u8"></video>';
    var httplivecontent = document.getElementById("httplivecontent");
	httplivecontent.appendChild(vlcString);
};

/**
 * @brief Updates the RTSP stream being played by the VLC plugin.
 * @warning This is required when streaming using VLC plugin in IE.
 * 
 * @param {stream} The stream url to be played
 */
function updateVLC(stream) {
	
	//alert(embed.playlist.items.count); return;
	
	var vlc = document.getElementById("vlc");

	vlc.playlist.playitem( vlc.playlist.add(stream,stream,":rtsp-caching=1000") );
	
	window.clearTimeout(timer);
	timer = -1;
}

/**
 * @brief Add the <img/> tag to the page to enable JPEG streaming
 * 
 * @param url The image stream source
 *        width Width of the image
 *        height Height of the image
 */
function embedJPEG( url, width, height,cam,cam_mode) {
	//imageURL = url + '?' + Math.random();
	//imageURL = url;
	imageWidth = width;
	imageHeight = height;
	cameraSelect = cam;
    cameraMode   = cam_mode;
	
	//alert("imageURL:"+imageURL);
    var imageString;
    if((cam_mode == CameraType.live) && ((cam%5) == 4))
    {	        			
		imageString = '<table align="center" border="2" cellpadding="0" cellspacing="0"  style="margin:auto">';
		imageString += '<tr>';
		//imageString += '<td style="margin:0;padding:0"><img height="'+height/2+'" width="'+width/2+'" src=/cgi-bin/img-0.cgi?0"'+'" id="bigimg0" name="bigimg0"/></td>';
		//imageString += '<td style="margin:0;padding:0"><img height="'+height/2+'" width="'+width/2+'" src=/cgi-bin/img-1.cgi?0"'+'" id="bigimg1" name="bigimg1"/></td>';
		if(cam==4)
		{
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap0.jpg"'+'" id="bigimg0" name="bigimg0"/></div></td>';
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap1.jpg"'+'" id="bigimg1" name="bigimg1"/></div></td>';
		}
		else
		{
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap4.jpg"'+'" id="bigimg0" name="bigimg0"/></div></td>';
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap5.jpg"'+'" id="bigimg1" name="bigimg1"/></div></td>';
		}
		imageString += '</tr>';

		imageString += '<tr>';
		//imageString += '<td style="margin:0;padding:0"><img height="'+height/2+'" width="'+width/2+'" src=/cgi-bin/img-2.cgi?0"'+'" id="bigimg2" name="bigimg2"/></td>';
		//imageString += '<td style="margin:0;padding:0"><img height="'+height/2+'" width="'+width/2+'" src=/cgi-bin/img-3.cgi?0"'+'" id="bigimg3" name="bigimg3"/></td>';
		if(cam==4)
		{
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap2.jpg"'+'" id="bigimg2" name="bigimg2"/></div></td>';
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap3.jpg"'+'" id="bigimg3" name="bigimg3"/></div></td>';
		}
		else
		{
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap6.jpg"'+'" id="bigimg2" name="bigimg2"/></div></td>';
		  imageString += '<td style="margin:0;padding:0"><div><img height="'+height/2+'" width="'+width/2+'" src="/tmp/snap7.jpg"'+'" id="bigimg3" name="bigimg3"/></div></td>';
		}
		imageString += '</tr>';

		imageString += '</table>';
		
    }
	else
	{
	    //imageURL = '/cgi-bin/img-' + cam.toString() + '.cgi' + '?' + Math.random();
	    if(cam_mode == CameraType.live)
	       imageURL = '/tmp/snap' + (parseInt(cam/5,10)*4+cam%5).toString()+ '.jpg';
		else
		   imageURL = '/tmp/snap' + cam.toString() + '.jpg';
        imageString = '<img height="'+height+'" width="'+width+'" src="'+imageURL+'" id="bigimg" name="bigimg" />';
	}

	var radiovar = document.getElementsByName("cam_choice");
	for(var i=0;i<radiovar.length;i++)
	{
	   if(radiovar[i].value==cameraSelect)//2ΪҪҵinputֵ
	    radiovar[i].checked = "checked";
	}
	
	setImageTimer();
	
	document.getElementById("imagecontent").style.visibility = "visible";
	$("#imagecontent").html(imageString);
}

/**
 * @brief Embed flash plugin to play RTMP stream
 */
function embedFlash( stream, width, height ) {
	$("#loader").appendTo("#flashcontent").show();
	
	/*************************************************/
	// Get the server ipaddress for RTMP streaming
	var ip = servers.getIP(location.hostname);
	stream = stream.replace(location.hostname,ip);
	stream = stream.replace("\r","");
	stream = stream.replace("\n","");
	/*************************************************/

	//var objectString = '<embed src="players/videoPlayer.swf" width="'+width+'" height="'+height+'" quality="high" bgcolor="#000000" name="videoPlayer" allowfullscreen="true" pluginspage="http://www.adobe.com/go/getflashplayer" flashvars="&videoWidth=0&videoHeight=0&dsControl=manual&dsSensitivity=100&serverURL='+stream+'&DS_Status=true&streamType=live&autoStart=true" type="application/x-shockwave-flash"></embed>';
	var file = stream.lastIndexOf("stream0") > -1 ? "stream0.flv" : "stream1.flv";
	var objectString = "<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' width='"+width+"' height='"+height+"' id='single1' name='single1'><param name='movie' value='players/player.swf'><param name='allowfullscreen' value='true'><param name='controlbar' value='none'><param name='allowscriptaccess' value='always'><param name='wmode' value='transparent'><param name='flashvars' value='file="+file+"&bufferlength=3&streamer="+stream+"'><embed type='application/x-shockwave-flash' id='single2' name='single2' src='players/player.swf' width='"+width+"' height='"+height+"' bgcolor='undefined' controlbar='none' allowscriptaccess='always' allowfullscreen='true' wmode='transparent' flashvars='file="+file+"&bufferlength=3&streamer="+stream+"&autostart=true&controlbar=none&stretching=fill'/></object>";
	$("#loader").appendTo("#loaderContainer").hide();
	$("#flashcontent").html(objectString);
}

/**
 * @brief Update the JPEG image to give the effect of streaming
 */
function updateImage() {	

	if((cameraMode== CameraType.live) && ((cameraSelect%5) == 4))
	{		
        if(cameraSelect==4)
		{
			if( document.getElementById("bigimg0") != undefined ) {						
				document.getElementById("bigimg0").src = '/cgi-bin/img-0.cgi' + '?' + Math.random();
				document.getElementById("bigimg0").width = imageWidth/2;
				document.getElementById("bigimg0").height = imageHeight/2;
			}
			if( document.getElementById("bigimg1") != undefined ) {
				document.getElementById("bigimg1").src = '/cgi-bin/img-1.cgi' + '?' + Math.random();
				document.getElementById("bigimg1").width = imageWidth/2;
				document.getElementById("bigimg1").height = imageHeight/2;
			}
			if( document.getElementById("bigimg2") != undefined ) {
				document.getElementById("bigimg2").src = '/cgi-bin/img-2.cgi' + '?' + Math.random();
				document.getElementById("bigimg2").width = imageWidth/2;
				document.getElementById("bigimg2").height = imageHeight/2;
			}
			if( document.getElementById("bigimg3") != undefined ) {
				document.getElementById("bigimg3").src = '/cgi-bin/img-3.cgi' + '?' + Math.random();
				document.getElementById("bigimg3").width = imageWidth/2;
				document.getElementById("bigimg3").height = imageHeight/2;
			}
        }
		else
		{
			if( document.getElementById("bigimg0") != undefined ) {						
				document.getElementById("bigimg0").src = '/cgi-bin/img-4.cgi' + '?' + Math.random();
				document.getElementById("bigimg0").width = imageWidth/2;
				document.getElementById("bigimg0").height = imageHeight/2;
			}
			if( document.getElementById("bigimg1") != undefined ) {
				document.getElementById("bigimg1").src = '/cgi-bin/img-5.cgi' + '?' + Math.random();
				document.getElementById("bigimg1").width = imageWidth/2;
				document.getElementById("bigimg1").height = imageHeight/2;
			}
			if( document.getElementById("bigimg2") != undefined ) {
				document.getElementById("bigimg2").src = '/cgi-bin/img-6.cgi' + '?' + Math.random();
				document.getElementById("bigimg2").width = imageWidth/2;
				document.getElementById("bigimg2").height = imageHeight/2;
			}
			if( document.getElementById("bigimg3") != undefined ) {
				document.getElementById("bigimg3").src = '/cgi-bin/img-7.cgi' + '?' + Math.random();
				document.getElementById("bigimg3").width = imageWidth/2;
				document.getElementById("bigimg3").height = imageHeight/2;
			}
        }
		window.setTimeout(arguments.callee, 909);
    }
	else
	{	
		//newImage = new Image();
		newImage.onload = imageLoaded;
		newImage.onerror = imageLoadError;
		//newImage.src = imageURL + '?' + Math.random();
		if(cameraMode == CameraType.live)
			newImage.src ='/cgi-bin/img-' + (parseInt(cameraSelect/5,10)*4+cameraSelect%5).toString() + '.cgi' + '?' + Math.random();			
		else	
		   newImage.src ='/cgi-bin/img-' + cameraSelect + '.cgi' + '?' + Math.random();
		//newImage.src ='/tmp/snap' + cameraSelect.toString() + '.jpg';

		if( document.getElementById("bigimg") != undefined ) {
			document.getElementById("bigimg").src = newImage.src;
			document.getElementById("bigimg").width = imageWidth;
			document.getElementById("bigimg").height = imageHeight;
		}
    }
}

/**
 * @brief Function that handles the successful load of the JPEG image
 */
function imageLoaded() {
	if(!clearTimer) { 
		timer = window.setTimeout(updateImage, 909);
	}
}

function imageLoadError() {
	if(!clearTimer) {
		timer = window.setTimeout(updateImage, 2000);
	}
}

/**
 * @brie Clear the timer that updates the JPEG stream
 */
function clearImageTimer() {
	window.clearTimeout(timer);
	clearTimer = true;
}

/**
 * @brief Set the timer for updating the JPEG stream
 */
function setImageTimer() {
	timer = window.setTimeout(updateImage, 909);
	clearTimer = false;
}

/**
 * @brief Add the <video/> tag to the page to enable HTTP live streaming
 */
function embedVIDEO( url, width, height ) {
	clearImageTimer();

	var videoString = '<video height="'+height+'" width="'+width+'" src="'+url+'" controls autoplay >';

	$("#videocontent").html(videoString);
}
