var camera = {};

camera.fliph = 0;
camera.flipv = 0;
camera.powerfrequence = 0;
camera.audiovolume = 95;
camera.brightness = 50;
camera.contrast = 50;
camera.hue = 50;
camera.saturaiton = 50;
camera.title = "CAM1";

camera.expsupported = 0;
camera.VOLUME_MIN = 0;
camera.VOLUME_MAX = 100;
camera.sensorwidth = 640;
camera.sensorheight = 360;

camera.beep = 0;
camera.bwmode = 1;

camera.downfps = 0;
camera.irled  = 0;
camera.ledindicator=0;

camera.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"INVALID_HORIZONTAL_FLIP" : 9,
	"INVALID_VERTICAL_FLIP" : 10,
	"INVALID_POWER_LINE_FREQUENCE" : 11, 
	"INVALID_AUDIO_VOLUME" : 12, 
	"FAILED_TO_FLIPH" : 13,
	"FAILED_TO_FLIPV" : 14,
	"FAILED_TO_SET_POWER_LINE_FREQUENCE" : 15,
	"FAILED_TO_SET_AUDIO_VOLUME" : 16	
};

camera.ResponseStrings = [
		"Success",
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error",
		"Database IO error",
		"An unknown error was encountered",
		"Invalid value for horizontal flip",
		"Invalid value for vertical flip",
		"Invalid value for power line frequence", 
		"Invalid value for audio volume", 
		"Invalid value for brightness",
		"Invalid value for contrast",
		"Invalid value for hue", 
		"Invalid value for saturation", 
		"Invalid value for title", 
		"Failed to flip the camera image horizontally. Please make sure that your camera is streaming",
		"Failed to flip the camera image vertically. Please make sure that your camera is streaming",
		"Failed to set the power line frequence. Please make sure that your camera is streaming",
		"Failed to set the audio volume. Please make sure that your camera is streaming",
		"Failed to set the camera brightness. Please make sure that your camera is streaming",
		"Failed to set the camera contrast. Please make sure that your camera is streaming",
		"Failed to set the camera hue. Please make sure that your camera is streaming",
		"Failed to set the camera saturation. Please make sure that your camera is streaming",
		"Failed to set the camera title. Please make sure that your camera is streaming",
		];

camera.get = function(idx) {
	//var para = parseInt(idx/5,10)*4+idx%5;
	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
		},
		url : "/cgi-bin/v1/camera/" + idx +"?"+Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/camera/" + para +"?"+Math.random(), "GET", err, textStatus);
		}
	});
    
	function getSuccessHandler(result) {

		$("#L1216").css( {
			visibility : "hidden"
		});
		var cameraNode = $(result).children("camera");
		var res = $(cameraNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res is not set");
			return;
		} else if (parseInt(res) != camera.ResponseCodes.SUCCESS) {
			alert("Error occurred. Result Code: " + res);
			return;
		}

		camera.parseResult(result);
		camera.setValues();
	}
};

camera.parseResult = function(xml) {
	var cameraNode = $(xml).children("camera");

	var flip = $(cameraNode).children("fliph");
	if (flip != undefined && flip.attr("b") != undefined)	
	{
		camera.fliph = parseInt(flip.attr("b"),10);		
	}

	flip = $(cameraNode).children("flipv");
	if (flip != undefined && flip.attr("b") != undefined)	
	{
		camera.flipv = parseInt(flip.attr("b"),10);		
	}

    flip = $(cameraNode).children("beep");
	if (flip != undefined && flip.attr("b") != undefined)	
	{
		camera.beep = parseInt(flip.attr("b"),10);		
	}
	
	var powerfrequence = $(cameraNode).children("frequence");
	if (powerfrequence != undefined && powerfrequence.attr("ul") != undefined)	
	{
		camera.powerfrequence = parseInt(powerfrequence.attr("ul"),10);		
	}
	
	var audiovolume = $(cameraNode).children("volume"); 
	if (audiovolume != undefined && audiovolume.attr("ul") != undefined)	
	{
	   camera.audiovolume =  parseInt(audiovolume.attr("ul"),10);		
	}

	var brightness = $(cameraNode).children("brightness");
	if (brightness != undefined && brightness.attr("ul") != undefined)	
	{
	   camera.brightness =  parseInt(brightness.attr("ul"),10);		
	}	

	var contrast = $(cameraNode).children("contrast");
	if (contrast != undefined && contrast.attr("ul") != undefined)	
	{
	   camera.contrast =  parseInt(contrast.attr("ul"),10);		
	}		

	var hue = $(cameraNode).children("hue");
	if (hue != undefined && hue.attr("ul") != undefined)	
	{
	   camera.hue =  parseInt(hue.attr("ul"),10);		
	}

	var saturation = $(cameraNode).children("saturation");
	if (saturation != undefined && saturation.attr("ul") != undefined)	
	{
	   camera.saturation =  parseInt(saturation.attr("ul"),10);		
	}
	
	var title = $(cameraNode).children("title");
	if (title != undefined && title.attr("s") != undefined )
	{
		camera.title = html_entity_decode(title.attr("s"));		
	}

	var bwmode = $(cameraNode).children("bwmode");
	if (bwmode != undefined && bwmode.attr("ul") != undefined)	
	{
	   camera.bwmode =  parseInt(bwmode.attr("ul"),10);		
	}

	bwmode = $(cameraNode).children("irled");
	if (bwmode != undefined && bwmode.attr("ul") != undefined)	
	{
	   camera.irled =  parseInt(bwmode.attr("ul"),10);		
	}

	bwmode = $(cameraNode).children("downfps");
	if (bwmode != undefined && bwmode.attr("ul") != undefined)	
	{
	   camera.downfps =  parseInt(bwmode.attr("ul"),10);		
	}

	bwmode = $(cameraNode).children("ledindicator");
	if (bwmode != undefined && bwmode.attr("ul") != undefined)	
	{
	   camera.ledindicator =  parseInt(bwmode.attr("ul"),10);		
	}
};

camera.put = function(idx) {
	function serializeXML() {		
		var fliph = $("#fliph").attr("checked") ? 1 : 0;
		var flipv = $("#flipv").attr("checked") ? 1 : 0;
		var beep  = $("#beep").attr("checked") ? 1 : 0;
		var powerfrequence = $("#power00").attr("checked") ? 0 :($("#power50").attr("checked")?1:2);
		var audiovolume = $("#txtvolume").val();
		var brightness = $("#txtbrightness").val();
		var contrast = $("#txtcontrast").val();
		var hue = $("#txthue").val();
		var saturation = $("#txtsaturation").val();
		var title = $("#txttitle").val();
		
        var bwmode = $("#op_autobw").val();
		var irled = $("#op_irled").val();
		if( $("#op_irled").attr("disabled") )
		{
          irled = -1;
		}
		var downfps = $("#op_downfps").val();
		var ledindicator = $("#op_indicator").val();
		
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<camera>';
		xml += '<fliph b="' + fliph + '"/>';
		xml += '<flipv b="' + flipv + '"/>';
		xml += '<beep b="' + beep + '"/>';
		xml += '<frequence ul="' + powerfrequence + '"/>';
		xml += '<volume ul="' + audiovolume + '"/>';
		
		xml += '<brightness ul="' + brightness + '"/>';
		xml += '<contrast ul="' + contrast + '"/>';
		xml += '<hue ul="' + hue + '"/>';
		xml += '<saturation ul="' + saturation + '"/>';
		xml += '<title s="' + title + '"/>';
		
		xml += '<bwmode ul="' + bwmode + '"/>';		
		xml += '<irled ul="' + irled + '"/>';
		xml += '<downfps ul="' + downfps + '"/>';
		xml += '<ledindicator ul="' + ledindicator + '"/>';
		
		xml += '</camera>';

		return xml;
	}

	var xml = serializeXML();
    var para = idx;//parseInt(idx/5,10)*4+idx%5;
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#btnImageProp").attr("disabled", true);
			$("#L1216").css( {
				visibility : "visible"
			});
			$("#L1216").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/camera/" + para +"?"+Math.random(),
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#btnImageProp").attr("disabled", false);
			$("#L1216").css( {
				visibility : "hidden"
			});
			handleError("/camera", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#btnImageProp").attr("disabled", false);
		//$("#L1216").css( {
		//	visibility : "hidden"
		//});

		var cameraNode = $(result).children("camera");
		var res = $(cameraNode).children("res").attr("ul");

		if (res == undefined)
		{
			//alert("res is not set");
			$("#L1216").html("");
		} 
		else if (parseInt(res) != camera.ResponseCodes.SUCCESS)
		{
			//alert("Error: " + camera.ResponseStrings[parseInt(res)]);
			$("#L1216").html("");
		}
        else
		{   
			$("#L1216").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
		}
		//camera.parseResult(result);
		//camera.setValues();
	}
};

camera.setValues = function() {
	
	$("#fliph").attr("checked", camera.fliph == 1);
	$("#flipv").attr("checked", camera.flipv == 1);
	$("#beep").attr("checked", camera.beep == 1);
	$("#power00").attr("checked", camera.powerfrequence == 0);
	$("#power50").attr("checked", camera.powerfrequence == 1);
	$("#power60").attr("checked", camera.powerfrequence == 2);
	$("#txtvolume").val(camera.audiovolume);
	$("#txtbrightness").val(camera.brightness);
	$("#txtcontrast").val(camera.contrast);
	$("#txthue").val(camera.hue);
	$("#txtsaturation").val(camera.saturation);
	$("#txttitle").val(camera.title);
	
	$("#op_autobw").val(camera.bwmode);	
	if(camera.irled > 1)
	{
        $("#op_irled").val(0);
		$("#op_irled").attr("disabled", true);
	}
	else
	{
	  $("#op_irled").val(camera.irled);
	  $("#op_irled").attr("disabled", false);
	}
	$("#op_downfps").val(camera.downfps);
	$("#op_indicator").val(camera.ledindicator);
		
	//if(getCookieLanguage()=="cn")
    {
       $("#btnAdvance").val(eval('button_res.'+getCookieLanguage()+'["Advance"]'));
       $("#btnImageProp").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    }   

	
};
