var jpg = {};
jpg.resolution = "";
jpg.numStreams = 0;

jpg.resolutions = new Array();

jpg.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

jpg.ResponseStrings = ["Success",
                        "Incorrect http method for this resource",
                        "Unsupported return mime-type",
                        "Unsupported attribute encountered for this resource",
                        "Unknown attribute encountered for this resource",
                        "Unknown property encountered for this resource",
                        "Message parsing error",
                        "Database IO error",
                        "An unknown error was encountered"];

jpg.Resolutions = {
	"RESOLUTION_QVGA" : 0,
	"RESOLUTION_VGA" : 1,
	"RESOLUTION_HD" : 2,
    "RESOLUTION_FULL_HD" : 3,
    "RESOLUTION_QCIF" : 4,
    "RESOLUTION_NUM" : 6
};

jpg.ResolutionStrings = {
	0 : "320x240",
	1 : "640x480",
	2 : "1280x720",
	3 : "1920x1080",
	4 : "240x160",
	5 : "NUM"
};

jpg.getStreamResolutions = function () {
	
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/encoders/jpeg",
		type: "GET",
		async: false,
		dataType: "xml",
		success: getJpgSuccessHandler,
		error: function(err, textStatus) {
			handleError("/encoders/jpeg", "GET", err, textStatus);
		}
	});
	var instance = 0;
	for (instance = 0; instance < jpg.numStreams; instance++) {
		$.ajax({
			beforeSend: function(xhrObj){
				xhrObj.setRequestHeader("Accept","application/xml");
			},
			url: "/cgi-bin/v1/encoders/jpeg/"+instance+"?"+Math.random(),
			type: "GET",
			async: false,
			dataType: "xml",
			success: getJpgInstanceSuccessHandler,
			error: function(err, textStatus) {
				handleError("/encoders/jpeg", "GET", err, textStatus);
			}
		});
	};
	
	function getJpgSuccessHandler(xml) {
		var encodersNode = $(xml).children("encoders");
		
		var res = $(encodersNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res not set");
			return;
		} else if (parseInt(res) != jpg.ResponseCodes.SUCCESS) {
			alert("Error: "+jpg.ResponseStrings[parseInt( res )]);
			return;
		}
		
		var jpgNode = $(encodersNode).children("jpeg");
		jpg.numStreams = parseInt($(jpgNode).attr("num"));
	};
	
	function getJpgInstanceSuccessHandler (xml) {
		var encodersNode = $(xml).children("encoders");
		
		var res = $(encodersNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res not set");
			return;
		} else if (parseInt(res) != jpg.ResponseCodes.SUCCESS) {
			alert("Error: "+jpg.ResponseStrings[parseInt( res )]);
			return;
		}
		
		var jpgNode = $(encodersNode).children("jpeg");
		
		var streamNode = $(jpgNode).children("stream");
		
		var resolutionNode = $(streamNode).children("resolution");
		if (resolutionNode == undefined || resolutionNode.attr("ul") == undefined) {
			alert("resolution not received");
			return;
		} else {
			jpg.resolutions[instance] = parseInt(resolutionNode.attr("ul"));
		}
	}
};

jpg.getResolution = function (stream) {
	return jpg.resolutions[stream];
};

jpg.setValues = function () {
	
};
