var gps = {};
gps.status = 0;
gps.osd = 0;
gps.speed=4800;
gps.timesync=0;

var GetGpsType = {
	"settings":0,
	"status":1
};

gps.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

gps.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

gps.get = function(opt) {	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");				
		},
		url : "/cgi-bin/v1/networks/gps/"+opt+"?"+Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/networks/gps", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{		
		var gpsNode = $(xml).children("gps");
		//alert(xml);
		var res = $(gpsNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != gps.ResponseCodes.SUCCESS) {
			//alert("Error: " + gps.ResponseStrings[parseInt(res)]);
			return;
		}       

        if(opt == GetGpsType.status)
		{
	        var valNode = $(gpsNode).children("status");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert("gps level not received");
				//return;
			}
			else 
			{
				gps.status = valNode.attr("ul");
			}
        }
		else
		{
			var valNode = $(gpsNode).children("speed");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert("gps level not received");
				//return;
			}
			else 
			{
				gps.speed = valNode.attr("ul");
			}
			
	        valNode = $(gpsNode).children("osd");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				gps.osd = parseInt(valNode.attr("ul"));
			}

	        valNode = $(gpsNode).children("timesync");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert("gps on hour not received");
				//return;
			}
			else 
			{
				gps.timesync = parseInt(valNode.attr("ul"));
			}		
		}
	}
};

gps.put = function(opt) 
{
	function serializeXML() {
		       
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<gps>';	
		xml += '<osd ul="' + $("#GpsOsd").val() + '"/>';
		xml += '<speed ul="' + $("#GpsSpeed").val() + '"/>';
		xml += '<timesync ul="' + ($("#enablesync").attr("checked") ? 1 : 0) + '"/>';		
		
		xml += '</gps>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1703").css( {
				visibility : "visible"
			});
			$("#button_gps").attr("disabled", true);
			$("#L1703").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/networks/gps/"+opt,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_gps").attr("disabled", false);
			$("#L1703").css( {
				visibility : "hidden"
			});
			handleError("/system/gps/" + camch, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_gps").attr("disabled", false);
		//$("#L1703").css( {
		//	visibility : "hidden"
		//});
		var gpsNode = $(result).children("gps");
		var res = $(gpsNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != gps.ResponseCodes.SUCCESS) {
				//alert("Error: " + gps.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			    $("#L1703").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

gps.setValues = function()
{
	$("#GpsOsd").val(gps.osd);
	$("#GpsSpeed").val(gps.speed);
    $("#enablesync").attr("checked", gps.timesync==1);

	$("#button_gps").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
    $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
};

gps.setStatus = function()
{
    $("#op_status").val(gps.status);
}