var power = {};
power.level = 0;
power.supercapacitor = 0;
power.accdelay=0;
power.accsleep=0;
power.almsleep=0;
power.onhour=0;
power.onmin=0;
power.offhour=0;
power.offmin=0;
	
power.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

power.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

power.get = function() {	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");	
			$("#L1504").css( {
				visibility : "visible"
			});
		},
		url : "/cgi-bin/v1/system/settings/power?"+Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/system/power", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{
		$("#L1504").css( {
				visibility : "hidden"
			});
		var powerNode = $(xml).children("power");
		//alert(xml);
		var res = $(powerNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res not set");
			return;
		} else if (parseInt(res) != power.ResponseCodes.SUCCESS) {
			alert("Error: " + power.ResponseStrings[parseInt(res)]);
			return;
		}       

		var valNode = $(powerNode).children("level");
		if (valNode == undefined || valNode.attr("b") == undefined)
		{
			//alert("power level not received");
			//return;
		}
		else 
		{
			power.level = parseInt(valNode.attr("b"));
		}

		valNode = $(powerNode).children("supercapacitor");
		if (valNode != undefined && valNode.attr("b") != undefined)
	
		{
			power.supercapacitor = parseInt(valNode.attr("b"));
		}
		
        valNode = $(powerNode).children("acc-delay");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert(" acc delay not received");
			//return;
		}
		else 
		{
			power.accdelay = parseInt(valNode.attr("ul"),10);
		}

        valNode = $(powerNode).children("accSleep");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert(" acc delay not received");
			//return;
		}
		else 
		{
			power.accsleep = parseInt(valNode.attr("ul"),10);
		}

		valNode = $(powerNode).children("alarmSleep");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert(" acc delay not received");
			//return;
		}
		else 
		{
			power.almsleep = parseInt(valNode.attr("ul"),10);
		}
		
        valNode = $(powerNode).children("on-hour");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("power on hour not received");
			//return;
		}
		else 
		{
			power.onhour = parseInt(valNode.attr("ul"),10);
		}

		valNode = $(powerNode).children("on-min");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("power level not received");
			//return;
		}
		else 
		{
			power.onmin = parseInt(valNode.attr("ul"),10);
		}

		valNode = $(powerNode).children("off-hour");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("power level not received");
			//return;
		}
		else 
		{
			power.offhour = parseInt(valNode.attr("ul"),10);
		}

		valNode = $(powerNode).children("off-min");
		if (valNode == undefined || valNode.attr("ul") == undefined)
		{
			//alert("power level not received");
			//return;
		}
		else 
		{
			power.offmin = parseInt(valNode.attr("ul"),10);
		}
	}
};

power.put = function(camch) 
{
	function serializeXML() {
		       
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<power>';	
		xml += '<level b="' + $("#op_ignition").val() + '"/>';
		xml += '<supercapacitor b="' + $("#op_supercapacitor").val() + '"/>';
		xml += '<acc-delay ul="' + $("#txt_acc_delay").val() + '"/>';
		xml += '<accSleep ul="' + $("#txt_acc_sleep").val() + '"/>';
		xml += '<alarmSleep ul="' + $("#txt_alm_sleep").val() + '"/>';
		xml += '<on-hour ul="' + $("#txt_on_hour").val() + '"/>';
		xml += '<on-min ul="' + $("#txt_on_min").val() + '"/>';
		xml += '<off-hour ul="' + $("#txt_off_hour").val() + '"/>';
		xml += '<off-min ul="' + $("#txt_off_min").val() + '"/>';
		
		xml += '</power>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1504").css( {
				visibility : "visible"
			});
			$("#button_power").attr("disabled", true);
			$("#L1504").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/system/settings/power?"+Math.random(),
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_power").attr("disabled", false);
			$("#L1504").css( {
				visibility : "hidden"
			});
			handleError("/system/power/" + camch, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_power").attr("disabled", false);
		//$("#L1504").hide();
		var powerNode = $(result).children("power");
		var res = $(powerNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != power.ResponseCodes.SUCCESS) {
				//alert("Error: " + power.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			   $("#L1504").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

power.setValues = function()
{
	$("#op_ignition").val(power.level);
	$("#op_supercapacitor").val(power.supercapacitor);
	$("#txt_acc_delay").val(power.accdelay);
	$("#txt_acc_sleep").val(power.accsleep);
	$("#txt_alm_sleep").val(power.almsleep);
    $("#txt_on_hour").val(power.onhour);
	$("#txt_on_min").val(power.onmin);	
	$("#txt_off_hour").val(power.offhour);
	$("#txt_off_min").val(power.offmin);	

	//if(getCookieLanguage()=="cn")
    {
       $("#button_power").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    } 
};

