var lan_settings = {};

lan_settings.priority = 0;
lan_settings.ipaddress = '192.168.10.254';
lan_settings.netmask = '255.255.255.0';
lan_settings.gateway = '0.0.0.0';

lan_settings.ResponseCodes = {
	"SUCCESS" : 0
};

lan_settings.ResponseStrings = ["Success"];


/**
 * @brief Performs a GET on the /networks/wifi/settings resource
 */
lan_settings.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
		    xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/networks/lan/settings?"+Math.random(),
		type: "GET",
		async: false,
		dataType: "xml",
		success: onResponse,
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			handleError("/networks/lan/settings", "GET", XMLHttpRequest, textStatus);
		}
	});
	
	function onResponse(xml) {
		var networksNode = $(xml).children("networks");
		var resultNode = $(networksNode).children("res");
		
		if ( resultNode.attr("ul") == undefined ) {
			//alert("XML Error: No result node");
			return;
		}

		if( parseInt(resultNode.attr("ul")) != lan_settings.ResponseCodes.SUCCESS ) 
		{
			//alert("Error: "+networksNode.ResponseStrings[parseInt( resultNode.attr("ul") )]);
			return;
		}
		
		var lanNode = $(networksNode).children("lan");
		var settingsNode = $(lanNode).children("settings");
		
		var ap = $(settingsNode).children("priority");
		if (ap != undefined && ap.attr("ul") != undefined) 
		{
			lan_settings.priority = parseInt(ap.attr("ul"));
		}

		
		ap = $(settingsNode).children("ipaddress");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			lan_settings.ipaddress = html_entity_decode(ap.attr("s"));
		}
		
		ap = $(settingsNode).children("netmask");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			lan_settings.netmask = html_entity_decode(ap.attr("s"));
		}
		
		ap = $(settingsNode).children("gateway");
		if (ap != undefined && ap.attr("s") != undefined) 
		{
			lan_settings.gateway = html_entity_decode(ap.attr("s"));
		}

	}
};

/**
 * @brief Performs a PUT on the /networks/wifi/settings resource
 */
lan_settings.put = function() {
	function serializeXML() {				

		var xml = '<?xml version="1.0"?>';
		xml += '<networks>';
		xml += '<lan>';
		xml += '<settings>';
		xml += '<priority ul="'+lan_settings.priority+'"/>';
		xml += '<ipaddress s="' + lan_settings.ipaddress + '"/>';
		xml += '<netmask s="' + lan_settings.netmask +'"/>';
		xml += '<gateway s="' + lan_settings.gateway +'"/>';
		xml += '</settings>';
		xml += '</lan>';
		xml += '</networks>';
		return xml;
	};

	var xml = serializeXML();

	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");

			$("#btn_settings_update").attr("disabled",true);
			$("#L1912").show();
			$("#L1912").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url: "/cgi-bin/v1/networks/lan/settings",
		type: "PUT",
		data: xml,
		dataType: "xml",
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#btn_settings_update").attr("disabled",false);
			$("#L1912").hide();
			handleError("/networks/lan/settings", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler( xml ) {
		$("#btn_settings_update").attr("disabled",false);
		//$("#L1912").hide();

		var networksNode = $(xml).children("networks");
		var resultNode = $(networksNode).children("res");

		if ( resultNode.attr("ul") == undefined ) {
			//alert("XML Error: No result node");
			return;
		}

		if( parseInt( resultNode.attr("ul") ) == lan_settings.ResponseCodes.SUCCESS )
		{
		   $("#L1912").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
		}
	}
};


lan_settings.setValues = function () 
{   

    $("#lan_priority").attr("checked", lan_settings.priority==1);
	   
	if(lan_settings.ipaddress != "")
	{
       var ips = lan_settings.ipaddress.split(".");
	   for(var i=0;i<4;i++) 
	   	   $("#ip"+i).val(ips[i]);
	}
	
	if(lan_settings.netmask != "")
	{
      var netmasks = lan_settings.netmask.split(".");
	  for(var i=0;i<4;i++)
	   	  $("#netmask"+i).val(netmasks[i]);
	}

	if(lan_settings.gateway != "")
	{
      var gateways = lan_settings.gateway.split(".");
	  for(var i=0;i<4;i++)
	   	  $("#gateway"+i).val(gateways[i]);
	}

	{
	   $("#btn_settings_update").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));	 
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
	}		
}
