var talkback = {};
talkback.mic = 80;
talkback.speaker=80;
talkback.device='default';

var GetTalkbackType = {
	"settings":0,
	"status":1
};

talkback.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

talkback.ResponseStrings = [ 
		"Success", 
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error", "Database IO error",
		"An unknown error was encountered"
];

talkback.get = function(opt) {	
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");	
			$("#L1504").css( {
				visibility : "visible"
			});
		},
		url : "/cgi-bin/v1/networks/talkback/"+ opt + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/networks/talkback", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml)
	{
		$("#L1504").css( {
				visibility : "hidden"
			});
		var talkbackNode = $(xml).children("talkback");
		//alert(xml);
		var res = $(talkbackNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res not set");
			return;
		} else if (parseInt(res) != talkback.ResponseCodes.SUCCESS) {
			alert("Error: " + talkback.ResponseStrings[parseInt(res)]);
			return;
		}       

        if(opt == GetTalkbackType.status)
		{
	        var  valNode = $(talkbackNode).children("device");
			if (valNode != undefined && valNode.attr("s") != undefined)			
			{
				talkback.device = valNode.attr("s");
			}				
		}		 
		else
		{
			var  valNode = $(talkbackNode).children("mic");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				talkback.mic = parseInt(valNode.attr("ul"),10);
			}

	        valNode = $(talkbackNode).children("speaker");
			if (valNode == undefined || valNode.attr("ul") == undefined)
			{
				//alert(" acc delay not received");
				//return;
			}
			else 
			{
				talkback.speaker = parseInt(valNode.attr("ul"),10);
			}
	    }
	}
};

talkback.put = function(opt) 
{
	function serializeXML() {
		       
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<talkback>';
		
		xml += '<mic ul="' + $("#txt_mic").val() + '"/>';
		xml += '<speaker ul="' + $("#txt_speaker").val() + '"/>';
		
		xml += '</talkback>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#L1504").css( {
				visibility : "visible"
			});
			$("#button_talkback").attr("disabled", true);
			$("#L1504").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/networks/talkback/"+opt,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_talkback").attr("disabled", false);
			$("#L1504").css( {
				visibility : "hidden"
			});
			handleError("/networks/talkback/" + camch, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#button_talkback").attr("disabled", false);
		//$("#L1504").hide();
		var talkbackNode = $(result).children("talkback");
		var res = $(talkbackNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != talkback.ResponseCodes.SUCCESS) {
				//alert("Error: " + talkback.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
			   $("#L1504").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

talkback.setValues = function()
{	
	$("#txt_mic").val(talkback.mic);
	$("#txt_speaker").val(talkback.speaker);
	
	//if(getCookieLanguage()=="cn")
    {
       $("#button_talkback").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    } 
};

talkback.setStatus = function()
{	
    if(talkback.device == 'default')
	{
	   $("#txt_mic").attr("disabled",false);
	   $("#txt_speaker").attr("disabled",false);
	   $("#button_talkback").attr("disabled",false);
	}	
	else
	{
	   $("#txt_mic").attr("disabled",true);
	   $("#txt_speaker").attr("disabled",true);
	   $("#button_talkback").attr("disabled",true);
	}
};

