var wificonn = {};
wificonn.status = 0;
wificonn.ssid='';
wificonn.ipaddress = '';
wificonn.netmask = '';
wificonn.gateway = '';
	
wificonn.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

wificonn.ResponseStrings = ["Success",
	                       "Incorrect http method for this resource",
	                       "Unsupported return mime-type",
	                       "Unsupported attribute encountered for this resource",
	                       "Unknown attribute encountered for this resource",
	                       "Unknown property encountered for this resource",
	                       "Message parsing error",
	                       "Database IO error",
	                       "An unknown error was encountered"];

/**
 * @brief Performs a GET on the /networks/wifi/conn resource
 */
wificonn.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
		    xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");			
		},
		url: "/cgi-bin/v1/networks/wifi/conn?"+Math.random(),
		type: "GET",
		async: false,
		dataType: "xml",
		success: onResponse,
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			//handleError("/networks/wifi/conn", "GET", XMLHttpRequest, textStatus);
		}
	});
	
	function onResponse(xml) {
		var networksNode = $(xml).children("networks");
		var resultNode = $(networksNode).children("res");
		
		if ( resultNode.attr("ul") == undefined ) {
			//alert("XML Error: No result node");
			return;
		}
		
		if( parseInt(resultNode.attr("ul")) != wificonn.ResponseCodes.SUCCESS ) {
			//alert("Error occurred. Result Code: " + res);
			//alert("Error: "+wificonn.ResponseStrings[parseInt( resultNode.attr("ul") )]);
			return;
		}
		
		var wifiNode = $(networksNode).children("wifi");
		var connNode = $(wifiNode).children("conn");

		var statusNode = $(connNode).children("ssid");
		if (statusNode != undefined && statusNode.attr("s") != undefined)
		{
			wificonn.ssid = statusNode.attr("s");
		}
		
		statusNode = $(connNode).children("connStatus");
		if (statusNode != undefined && statusNode.attr("ul") != undefined)
		{
			wificonn.status = statusNode.attr("ul");
		}
		
		if(wificonn.status > 0)
		{
		
			var ipaddressNode = $(connNode).children("ipaddress");
			if (ipaddressNode != undefined && ipaddressNode.attr("s") != undefined)
			{
				wificonn.ipaddress = html_entity_decode(ipaddressNode.attr("s"));
			}
			
			var netmaskNode = $(connNode).children("netmask");
			if (netmaskNode != undefined && netmaskNode.attr("s") != undefined) 
			{
				wificonn.netmask = html_entity_decode(netmaskNode.attr("s"));
			}

			netmaskNode = $(connNode).children("gateway");
			if (netmaskNode == undefined || netmaskNode.attr("s") == undefined) {
				wificonn.gateway="";
			} else {
				wificonn.gateway = html_entity_decode(netmaskNode.attr("s"));
			}
		}	
		
		

	}
};

wificonn.setValues = function() {

    var index = $("#op_ipmode").val();
	if(index == "1")
	{
	  if(wificonn.status > 0 && wificonn.ssid == wifisettings.cli_ssid)
	  {
		if(wificonn.ipaddress != "")
		{
	       var ips = wificonn.ipaddress.split(".");
		   for(var i=0;i<4;i++) 
		   	   $("#ip"+i).val(ips[i]);
		}
		
		if(wificonn.netmask != "")
		{
	      var netmasks = wificonn.netmask.split(".");
		  for(var i=0;i<4;i++)
		   	  $("#netmask"+i).val(netmasks[i]);
		}

		
		for(var i=0;i<4;i++)
  	    {
  		  $("#ip"+i).attr("disabled", true);
  		  $("#netmask"+i).attr("disabled", true);
  	    }
  	    $("#gateway_show").css("display", "none");
  	    $("#ip_show").css("display", "");
	  }
	  else
	  {	
	  	$("#ip_show").css("display", "none");
	  }
	}
	else
	{	   
  	   $("#ip_show").css("display", "");
	   $("#gateway_show").css("display", "");
	}
};
