var memcard = {};
memcard.diskindex = 3;
memcard.detected = 0;
memcard.mntsate = 0;
memcard.totalmem = 0;
memcard.freemem = 0;
memcard.enableAutoDelete = 0;
memcard.minMem = 0;
memcard.maxMem = 0;

memcard.MIN_MEM_PERCENT_MIN = 10;
memcard.MIN_MEM_PERCENT_MAX = 50;
memcard.MAX_MEM_PERCENT_MIN = 60;
memcard.MAX_MEM_PERCENT_MAX = 90;

memcard.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"INVALID_BOOLEAN_ENABLEAUTODELETE" : 9,
	"INVALID_MIN_MEM_PERCENT" : 10,
	"INVALID_MAX_MEM_PERCENT" : 11,
	"INVALID_ACTION" : 12,
	"INVALID_SOURCE_FILE" : 13,
	"INVALID_DEST_DIR" : 14,
	"INVALID_DEST_FILE" : 15,
	"MEMCARD_NOT_DETECTED" : 16,
	"SOURCE_FILE_NOT_FOUND" : 17,
	"SOURCE_DIR_NOT_FOUND" : 18,
	"DEST_DIR_NOT_FOUND" : 19,
	"FAILED_TO_MOVE_FILE" : 20,
	"FAILED_TO_RENAME_FILE" : 21,
	"FAILED_TO_DELETE_FILE" : 22
};

memcard.ResponseStrings = ["Success",
                                 "Incorrect http method for this resource",
                                 "Unsupported return mime-type",
                                 "Unsupported attribute encountered for this resource",
                                 "Unknown attribute encountered for this resource",
                                 "Unknown property encountered for this resource",
                                 "Message parsing error",
                                 "Database IO error",
                                 "An unknown error was encountered",
                                 "Invalid boolean value set for enable auto delete",
                             	 "Invalid min memory percent",
                             	 "Invalid max memory percent",
                                 "Invalid memory card action",
                                 "Could not find the source file",
                         		 "Invalid destination directory/Destination directory not specified",
                         		 "Destination file not specified",
                         		 "Memory card not detected",
                         		 "Could not find source file",
                         		 "Could not find source directory",
                         		 "Could not find destination directory",
                         		 "Failed to move file",
                         		 "Failed to rename file",
                         		 "Failed to delete file"];

memcard.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/storage/memcard?"+Math.random(),
		type: "GET",
		async: false,
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/storage/memcard", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler (result) {
		var storageNode = $(result).children("storage"); 
		var res = $(storageNode).children("res").attr("ul");
		if (res == undefined)
		{
			return;
		} 
		else if (parseInt(res) != memcard.ResponseCodes.SUCCESS) 
		{
			return;
		}
		
		var memcardNode = $(storageNode).children("memcard");
		
		var val = $(memcardNode).children("diskindex");
		if (val != undefined && val.attr("ul") != undefined)
		{			
			memcard.diskindex = parseInt(val.attr("ul"));
		}

        val = $(memcardNode).children("devstate");
		if (val != undefined && val.attr("ul") != undefined)
		{			
			memcard.detected = parseInt(val.attr("ul"));
		}

		val = $(memcardNode).children("mntstate");
		if (val != undefined && val.attr("ul") != undefined)
		{			
			memcard.mntstate = parseInt(val.attr("ul"));
		}
		
		if (memcard.detected == 1)
		{
			var mem = $(memcardNode).children("totalmem");
			if (mem != undefined && mem.attr("ul") != undefined)
			{
				memcard.totalmem = parseInt(parseInt(mem.attr("ul"))/1000,10);
			}
			
			mem = $(memcardNode).children("freemem");
			if (mem != undefined && mem.attr("ul") != undefined)
			{
				memcard.freemem = parseInt(parseInt(mem.attr("ul"))/1000,10);
			}
		}
		
		val = $(memcardNode).children("enableAutoDelete");
		if (val != undefined && val.attr("b") != undefined)
		{
			memcard.enableAutoDelete = parseInt(val.attr("b"));
		}
		/*
		var minMem = $(memcardNode).children("minMem");
		if (minMem == undefined || minMem.attr("ul") == undefined) {
			//alert("<minMem ul=''/> not found");
			return;
		} else {
			memcard.minMem = parseInt(minMem.attr("ul"));
		}
		
		var maxMem = $(memcardNode).children("maxMem");
		if (maxMem == undefined || maxMem.attr("ul") == undefined) {
			//alert("<maxMem ul=''/> not found");
			return;
		} else {
			memcard.maxMem = parseInt(maxMem.attr("ul"));
		}
		*/
	}
};

memcard.updateMemCardSettings = function () {
	function serializeXML () {
		var enableAutoDelete = $("#checkAutoDelete").attr("checked") ? "1" : "0";
		//var maxMem = $("#txtMaxMem").val();
		//var minMem = $("#txtMinMem").val();
		
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<storage>';
		xml += '<memcard>';
		
		xml += '<enableAutoDelete b="'+enableAutoDelete+'"/>';
		//xml += '<maxMem ul="'+maxMem+'"/>';
		//xml += '<minMem ul="'+minMem+'"/>';

		xml += '</memcard>';
		xml += '</storage>';
		return xml;
	}
	
	var xml = serializeXML();
	
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");

			$("#btnMemCard").attr("disabled",true);
			$("#spanLoaderMemCard").css({visibility:"visible"});
			$("#spanUpdateMemCard").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url: "/cgi-bin/v1/storage/memcard",
		type: "PUT",
		dataType: "xml",
		data: xml,
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#btnMemCard").attr("disabled",false);
			$("#spanLoaderMemCard").css({visibility:"hidden"});
			handleError("/storage/memcard", "PUT", err, textStatus);
		}
	});
	
	function putSuccessHandler( result ) {
		$("#btnMemCard").attr("disabled",false);
		//$("#spanLoaderMemCard").css({visibility:"hidden"});
		var storageNode = $(result).children("storage");
		
		var res = $(storageNode).children("res").attr("ul");
		if(res == undefined) {
			//alert("result not set");
			return;
		} 
		else
		{
			if( parseInt(res) != memcard.ResponseCodes.SUCCESS ) {
				//alert("Error: "+memcard.ResponseStrings[parseInt( res )]);
				return;
			}
			else
			{
               $("#spanUpdateMemCard").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
}

memcard.put = function(opt) {
	function serializeXML () {
		var xml = '<?xml version="1.0"?>\r\n';
		xml += '<storage>';
		xml += '<memcard>';
		
		xml += '</memcard>';
		xml += '</storage>';
		return xml;
	}
	
	var xml = serializeXML();
	
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/storage/memcard/"+opt,
		type: "PUT",
		dataType: "xml",
		data: xml,
		success: putSuccessHandler,
		error: function(err, textStatus) {
			handleError("/storage/memcard", "PUT", err, textStatus);
		}
	});
	
	function putSuccessHandler( result ) {
		var storageNode = $(result).children("storage");
		
		var res = $(storageNode).children("res").attr("ul");
		if(res == undefined) {
			//alert("result not set");
			return;
		} else {
			if( parseInt(res) != memcard.ResponseCodes.SUCCESS ) {
				//alert("Error: "+memcard.ResponseStrings[parseInt( res )]);
				return;
			}
		}
		
		list();
	}
};

memcard.setValues = function () {
	if (memcard.detected == 1) 
	{	  
		{
		   $("#spanMemcardDetected").html(eval('tip_res.'+getCookieLanguage()+'["Disk Found"]')+"<br/>");
		   $("#spanMemcardTotalMemory").html(eval('tip_res.'+getCookieLanguage()+'["Total Memory"]')+memcard.totalmem+" Mb<br/>");
		   $("#spanMemcardFreeMemory").html(eval('tip_res.'+getCookieLanguage()+'["Free Memory"]')+memcard.freemem+" Mb<br/>");
	    }
	}
	else if (memcard.detected == 0x3) 
	{	  
		{
		   $("#spanMemcardDetected").html(eval('tip_res.'+getCookieLanguage()+'["Disk Unformatted"]'));		   
	    }
	}
	else if (memcard.detected == 0x0)  
    {
         $("#spanMemcardDetected").html(eval('tip_res.'+getCookieLanguage()+'["No Disk"]'));
		 $("#btnFormat").attr("disabled", true);;
	}		
	else  
    {
         $("#spanMemcardDetected").html(eval('tip_res.'+getCookieLanguage()+'["Disk Error"]'));
		 $("#btnFormat").attr("disabled", true);;
	}	
	
	$("#checkAutoDelete").attr("checked",(memcard.enableAutoDelete==1));
	$("#txtMaxMem").val(memcard.maxMem);
	$("#txtMinMem").val(memcard.minMem);
};
