var datetime = {};
datetime.year = 0;
datetime.dayStr = "";
datetime.day = 0;
datetime.monthStr = "";
datetime.month = 0;
datetime.hours = 0;
datetime.minutes = 0;
datetime.seconds = 0;
datetime.tzabbr = "";
datetime.tz = "";
datetime.tzstring = "";
datetime.dst = "0";
datetime.dt  = "none";
datetime.format = "0";
datetime.tzchange = 0;

datetime.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"IO_ERROR" : 9,
	"INVALID_TIMEZONE" : 10,
	"INVALID_TIMEZONE_STRING" : 11
};

datetime.ResponseStrings = ["Success",
                           "Incorrect http method for this resource",
                           "Unsupported return mime-type",
                           "Unsupported attribute encountered for this resource",
                           "Unknown attribute encountered for this resource",
                           "Unknown property encountered for this resource",
                           "Message parsing error",
                           "Database IO error",
                           "An unknown error was encountered",
                           "An IO error occured. Please try again.",
                           "The timezone you selected is invalid",
                           "The timezone string you selected is invalid"];

datetime.get = function () {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/system/settings/datetime?"+Math.random(),
		type: "GET",
		dataType: "xml",
		async: false,
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/system/settings/datetime", "GET", err, textStatus);
		}
	});

	function getSuccessHandler (xml) {
		var systemNode = $(xml).children("system");

		var res = $(systemNode).children("res").attr("ul");
		if (res == undefined) {
			alert("res not set");
			return;
		} else if (parseInt(res) != datetime.ResponseCodes.SUCCESS) {
			alert("Error! " + datetime.ResponseStrings[parseInt(res)]);
			return;
		}
		
		var settingsNode = $(systemNode).children("settings");

		var datetimeNode = $(settingsNode).children("datetime");
		
		// Get <date> node
		var dateNode = $(datetimeNode).children("date");
		var dayNode = $(dateNode).children("day");
		datetime.day = parseInt(dayNode.attr("ul"),10);
		datetime.dayStr = dayNode.attr("s");
		
		var monthNode = $(dateNode).children("month");
		datetime.month =  parseInt(monthNode.attr("ul"),10);		
		datetime.monthStr = monthNode.attr("s");
		
		var yearNode = $(dateNode).children("year");
		datetime.year = parseInt(yearNode.attr("ul"),10);
		
		// Get time node
		var timeNode = $(datetimeNode).children("time");
		var hoursNode = $(timeNode).children("hours");
		datetime.hours = parseInt(hoursNode.attr("ul"),10);
		
		var minutesNode = $(timeNode).children("minutes");
		datetime.minutes = parseInt(minutesNode.attr("ul"),10);
		
		var secondsNode = $(timeNode).children("seconds");
		datetime.seconds = parseInt(secondsNode.attr("ul"),10);
		
		// Get the timezone node
		var timezoneNode = $(datetimeNode).children("timezone");		
		var tzNode = $(timezoneNode).children("tz");
		var tzstringNode = $(timezoneNode).children("tzstring");
		var tzDst = $(timezoneNode).children("dst");
		var dtFormat = $(timezoneNode).children("format");
		datetime.dst = tzDst.attr("ul");
		datetime.format = parseInt(dtFormat.attr("ul"));
		datetime.tz = tzNode.attr("s");
		datetime.tzstring = tzNode.attr("s");
		
		// unescape
		datetime.tzstring = html_entity_decode(datetime.tzstring);
		datetime.tz = html_entity_decode(datetime.tz);
		//datetime.tzabbr = html_entity_decode(datetime.tzabbr);
		datetime.monthStr = html_entity_decode(datetime.monthStr);
		datetime.dayStr = html_entity_decode(datetime.dayStr);
	}
};

datetime.put = function () {
	function serializeXML (encrypted_password)
    {        
		var tz = $("#select_timezone").val();
		var tzstring = get_timezone_string(tz);
		var tzcfg = get_timezone_cfgstring(tz);
		var dst = $("#setdst").val();
        var dtFormat = $("#dtformat").val();
		// escape
		tzstring = htmlentities(tzstring);
		
		var xml = '<?xml version="1.0"?>';
		xml += '<system>';
		xml += '<settings>';
		xml += '<datetime>';
		xml += '<timezone>';
		xml += '<dt s="'+datetime.dt+'"/>';
		xml += '<tz s="'+tz+'"/>';
		xml += '<tzstring s="'+tzstring+'"/>';
		xml += '<tzcfg s="'+tzcfg+'"/>';
		xml += '<dst ul="'+dst+'"/>';
		xml += '<format ul="'+dtFormat+'"/>';
		xml += '</timezone>';
		xml += '</datetime>';
		xml += '</settings>';
		xml += '</system>';
		
		return xml;
	}

	var xml = serializeXML();

	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type","application/xml");
			
			$("#button_datetime").attr("disabled", true);
			$("#L2107").css({visibility:"visible"});
			$("#L2107").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url: "/cgi-bin/v1/system/settings/datetime",
		type: "PUT",
		data: xml,
		dataType: "xml",
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#button_datetime").attr("disabled", false);
			$("#L2107").css({visibility:"hidden"});
			handleError("/system/settings/datetime", "PUT", err, textStatus);
		}
	});
	
	function putSuccessHandler (result) {
		$("#button_datetime").attr("disabled", false);
		//$("#L2107").css({visibility:"hidden"});
		var systemNode = $(result).children("system");
		var res = $(systemNode).children("res").attr("ul");
		
		if(res == undefined) {
			//alert("result not set");
			return;
		} else {
			if( parseInt(res) != datetime.ResponseCodes.SUCCESS ) {
				//alert("Error occurred. Result Code: " + res);
				//alert("Error: "+datetime.ResponseStrings[parseInt( res )]);
				return;
			}
			else 
			{
			   	$("#L2107").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			    if(datetime.tzchange > 0)
			    {
                   datetime.tzchange = 0;
				   datetime.get();
				   datetime.get();
				   datetime.setValues();
				}
				
			}
		}
	}
};

datetime.setValues = function()
{
	if(datetime.month<10) D1month="0"+datetime.month;
	else D1month=""+datetime.month;
	if(datetime.day<10) D1day="0"+datetime.day;
	else D1day=""+datetime.day;
	if(datetime.hours<10) D1hour="0"+datetime.hours;
	else D1hour=""+datetime.hours;
	if(datetime.minutes<10) D1minute="0"+datetime.minutes;
	else D1minute=""+datetime.minutes;
	if(datetime.seconds<10) D1second="0"+datetime.seconds;
	else D1second=""+datetime.seconds;
	if(datetime.format == "0")				
	   $("#stime").val(datetime.year+'-'+D1month+'-'+D1day+' '+D1hour+':'+D1minute+':'+D1second);
	else if(datetime.format == "1")				
	   $("#stime").val(D1month+'-'+D1day+'-'+datetime.year+' '+D1hour+':'+D1minute+':'+D1second);
	else
	    $("#stime").val(D1day+'-'+D1month+'-'+datetime.year+' '+D1hour+':'+D1minute+':'+D1second);
	$("#select_timezone").val(datetime.tz);
	$("#setdst").val(datetime.dst);
	$("#dtformat").val(datetime.format);

	//if(getCookieLanguage()=="cn")
    {
	   $("#button_datetime").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
       $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    } 
};
