var produceMac = {};
produceMac.g3id = '';
produceMac.macs = new Array(6);

produceMac.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8
};

produceMac.ResponseStrings = ["Success",
                                "Incorrect http method for this resource",
                                "Unsupported return mime-type",
                                "Unsupported attribute encountered for this resource",
                                "Unknown attribute encountered for this resource",
                                "Unknown property encountered for this resource",
                           	  	"Message parsing error",
                           	  	"Database IO error",
                           	  	"An unknown error was encountered"];

produceMac.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
		},
		url: "/cgi-bin/v1/system/settings/produceMac?"+Math.random(),
		async: false,
		type: "GET",
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/settings/produceMac", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler (result) {
		var rootNode = $(result).children("produce");
		var res = $(rootNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != produceMac.ResponseCodes.SUCCESS) 
			{
				return;
			} 
			else 
			{
			    var valNode = $(rootNode).children("g3id");
				if (valNode != undefined && valNode.attr("s") != undefined)				
				{
					produceMac.g3id = valNode.attr("s");
				}

				var macsNode = $(rootNode).children("macs");
				var macNode = $(macsNode).children("mac");

				for(i=0;i<macNode.length;i++)
			    {					
					if ($(macNode[i]).attr("s") != undefined) 
					{
						produceMac.macs[i] = $(macNode[i]).attr("s");
					} 

				}
		
	        }
		}
	}	
	
};

produceMac.put = function () {
	function serializeXML() {				

        var xml = '<?xml version="1.0"?>\r\n';
		xml += '<produce>';			
		xml += '<g3id s="' + $("#txt_number").val() + '"/>';
		xml += '<macs>';

		for(i=0;i<6;i++)
		{
		  xml += '<mac s="' + $("#txt_mac"+i).val() + '"/>';		
		}
		xml += '</macs>';
		xml += '</produce>';

		return xml;
	}

	var xml = serializeXML();
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
			$("#button_apply").attr("disabled", true);
			//$("#tip_mac").css({visibility:"visible"});
			$("#tip_mac").html("It is updating...");
		},
		url: "/cgi-bin/v1/system/settings/produceMac",
		type: "PUT",
		data: xml,
		dataType: "xml",
		async: true,
		success: putSuccessHandler,
		error: function(err, textStatus) {
			$("#button_apply").attr("disabled", false);
			$("#tip_mac").css({visibility:"hidden"});
		}
	});

	function putSuccessHandler (xml) {
		$("#button_apply").attr("disabled", false);
		var systemNode = $(xml).children("produce");

		var res = $(systemNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} 
		else if (parseInt(res) != produceMac.ResponseCodes.SUCCESS)
		{
		    $("#tip_mac").html("Apply Failed");
		}
		else
		{
			
			$("#tip_mac").html("Apply Successfully");
		}	
				
	}
};

produceMac.setValues = function () {

    $("#txt_number").val(produceMac.g3id);
	
	for(i=0;i<6;i++)
	{
	  $("#txt_mac"+i).val(produceMac.macs[i]);
	}
};	