var details = {};
details.level = new Array();
details.record = ["0xff","0xff","0xff","0xff"];
details.osd = ["sensor1","sensor2","sensor3","lanc"];
details.buzzer = ["0","0","0","0"];
details.switchview = ["0","0","0","0"];
details.switchdelay = ["0","0","0","0"];
details.select = [0,0,0,0];
details.prerecord = "5";
details.postrecord = "5";
details.cds = -1;
details.localalarm = 0;

details.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"INVALID_ROI_PERCENT" : 9,
	"INVALID_RESOLUTION" : 10,
	"INVALID_PRETIME" : 11,
	"INVALID_POSTTIME" : 12,
	"INVALID_MIN_EVENTTIME" : 13,
	"INVALID_MAX_EVENTTIME" : 14,
	"FAILED_TO_SET_TRIGGERS_VALUES" : 15
};

details.ResponseStrings = [
		"Success",
		"Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error",
		"Database IO error",
		"An unknown error was encountered",
		"Invalid ROI percent value",
		"Invalid resolution value",
		"Invalid pretime",
		"Invalid posttime",
		"Invalid min event time",
		"Invalid max event time",
		"Database updated, but failed to apply settings. Please make sure that your camera is on and streaming" ];

details.get = function() {
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
		},
		url : "/cgi-bin/v1/triggers/details"+ "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/triggers/details", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml) {
		var triggersNode = $(xml).children("triggers");
		var resultNode = $(triggersNode).children("res");

		if (resultNode.attr("ul") == undefined) {
			//alert("XML Error: No result node");
			return;
		}

		if (parseInt(resultNode.attr("ul")) != details.ResponseCodes.SUCCESS) {
			//alert("Error! "	+ details.ResponseStrings[parseInt(resultNode.attr("ul"))]);
			return;
		}

		var sensorNode = $(triggersNode).children("sensor");

		for(i=0;i<sensorNode.length;i++)
	    {
			var level = $(sensorNode[i]).children("level");
			if (level == undefined || level.attr("ul") == undefined) 
			{
				//alert("trigger level value not received");
				//return;
			} 
			else
			{
				details.level[i] = level.attr("ul");
			}

			level = $(sensorNode[i]).children("buzzer");
			if (level == undefined || level.attr("ul") == undefined) 
			{
				//alert("trigger buzzer value not received");
				//return;
			} 
			else
			{
				details.buzzer[i] = level.attr("ul");
			}
			
			var record = $(sensorNode[i]).children("record");
			if (record == undefined || record.attr("s") == undefined)
			{
				//alert("trigger record value not received");
				//return;
			}
			else 
			{
				details.record[i] = record.attr("s");
			}

	        var osd = $(sensorNode[i]).children("osd");
			if (osd == undefined || osd.attr("s") == undefined)
			{
				//alert("osd text not received");
				//return;
			}
			else 
			{
				details.osd[i] = osd.attr("s");
			}

			var switchs = $(sensorNode[i]).children("switchview");
			if (switchs != undefined && switchs.attr("ul") != undefined )			
			{
				details.switchview[i] = switchs.attr("ul");
			}

			switchs = $(sensorNode[i]).children("switchdelay");
			if (switchs != undefined && switchs.attr("ul") != undefined )			
			{
				details.switchdelay[i] = switchs.attr("ul");
			}
	    }

		var interval = $(triggersNode).children("prerecord");
		if (interval == undefined || interval.attr("ul") == undefined) 
		{
			//alert("trigger level value not received");
			//return;
		} 
		else
		{
			details.prerecord = interval.attr("ul");
		}

		interval = $(triggersNode).children("postrecord");
		if (interval == undefined || interval.attr("ul") == undefined) 
		{
			//alert("trigger level value not received");
			//return;
		} 
		else
		{
			details.postrecord = interval.attr("ul");
		}

		interval = $(triggersNode).children("cds");
		if (interval == undefined || interval.attr("ul") == undefined) 
		{
			//alert("trigger level value not received");
			//return;
		} 
		else
		{
			details.cds = parseInt(interval.attr("ul"),10);
		}

		interval = $(triggersNode).children("localalarm");
		if (interval != undefined && interval.attr("ul") != undefined) 
		{
			details.localalarm = parseInt(interval.attr("ul"),10);
		}
	}
};

details.put = function() {

	function serializeJSON() {
	}

	function serializeXML() {
		// showStatus('Applying details changes ... please wait');


		var xml = '<?xml version="1.0"?>';
		xml += '<triggers><sensors>';
		
		for(i=1;i<=4;i++)
		{
		  var level =  $("#op_almlevel"+i).val();
		  var record = details.record[i-1];
		  var osd =    $("#txt_almosd"+i).val();
		  var buzzer = $("#op_almbuzzer"+i).val();
		  var switchview = $("#op_switchview"+i).val();
		  var switchdelay = $("#op_switchdelay"+i).val();
	
		  xml += '<sensor level="' + level + '" record="' + record + '" osd="' + osd + '" buzzer="' + buzzer + '" switchview="' + switchview+ '" switchdelay="' + switchdelay +'" />';
		}
        xml += '</sensors>';
        xml += '<prerecord ul="'  + $("#op_prerecord").val() + '"/>';
		xml += '<postrecord ul="' + $("#op_postrecord").val() + '"/>';
		if($("#show_cds").is(":visible"))
		{
           xml += '<cds ul="' + $("#txt_cds").val() + '"/>';
		}
		xml += '</triggers>';

		return xml;
	}
	;

	var serializedXML = serializeXML();

	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");
            $("#L1305").css( {
				visibility : "visible"
			});
			$("#button_apply").attr("disabled", true);
			$("#L1305").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
		},
		url : "/cgi-bin/v1/triggers/details",
		type : "PUT",
		data : serializedXML,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#button_apply").attr("disabled", false);
			$("#L1305").hide();
			handleError("/triggers/details", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(xml) {
		$("#button_apply").attr("disabled", false);
		//$("#L1305").hide();

		var triggersNode = $(xml).children("triggers");
		var resultNode = $(triggersNode).children("res");

		if (resultNode.attr("ul") == undefined) {
			//alert("XML Error: No result node");
			return;
		}

		if (parseInt(resultNode.attr("ul")) != details.ResponseCodes.SUCCESS) {
			//alert("Error! "					+ details.ResponseStrings[parseInt(resultNode.attr("ul"))]);
		} 
		else
		{
		    $("#L1305").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
		}
	}
};

details.setValues = function() {
	for(i=1;i<=4;i++)
	{
	  $("#op_almlevel"+i).val(details.level[i-1]);
	  $("#txt_almrecord"+i).val(changeRecordTips(parseInt(details.record[i-1],16)));
	  $("#txt_almosd"+i).val(details.osd[i-1]);	
	  $("#op_almbuzzer"+i).val(details.buzzer[i-1]);
	  $("#op_switchview"+i).val(details.switchview[i-1]);
	  $("#op_switchdelay"+i).val(details.switchdelay[i-1]);
	}

	$("#op_prerecord").val(details.prerecord);
	$("#op_postrecord").val(details.postrecord);

	if(details.cds < 0)
	{
       $("#show_cds").hide();
	}
	else
	{
       $("#txt_cds").val(details.cds);
	   $("#show_cds").show();
	}
	//if(getCookieLanguage()=="cn")
    {
       $("#button_apply").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
	   $("#button_help").val(eval('button_res.'+getCookieLanguage()+'["Help Right"]'));
    }  
};
